<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: datawarehouse_info.php,v 1.27 2006/10/15 18:11:21 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
        $USERNAME = "Got_no_username";
        session_register("$USERNAME");
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $PASSWORD = "Got_no_password";
        session_register("$PASSWORD");
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("authenticate_role.php");
include("functions.php");
verify_lce();
verify_lce_days();


//Executing query based on users input otherwise default settings
$query         = "select hostname from andutteye_heartbeat order by hostname asc";
$result1       = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather specific hosts to search on\n"); 

echo "<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
  <td class='topleft'>
     <div class='armature1'></div>
    </td>
   <td class='top'></td>
       <td class='topright'></td>
        </tr>
        <tr>
         <td class='left'></td>
<td class='fill'>";

echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='100%'>";


while ($line = $DBFETCHARRAY($result1, $DBASSOC )) {
        $HOST_VALUE = $line["hostname"];
	$HOSTNAME = $HOST_VALUE;

	$query         = "select count(*) from andutteye_alarm where severity = 'HARMLESS' and hostname = '$HOST_VALUE'";
	$result        = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather datawarehouse information\n"); 
	$tmpharmless   = $DBFETCHARRAY($result);
	$HARMLESS      =$tmpharmless[0];
	
	$query         = "select count(*) from andutteye_alarm where severity = 'WARNING' and hostname = '$HOST_VALUE'";
	$result        = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather datawarehouse information\n"); 
	$tmpwarning    = $DBFETCHARRAY($result);
	$WARNING       =$tmpwarning[0];
	
	$query         = "select count(*) from andutteye_alarm where severity = 'CRITICAL' and hostname = '$HOST_VALUE'";
	$result        = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather datawarehouse information\n"); 
	$tmpcritical   = $DBFETCHARRAY($result);
	$CRITICAL      =$tmpcritical[0];
	
	$query         = "select count(*) from andutteye_alarm where severity = 'FATAL' and hostname = '$HOST_VALUE'";
	$result        = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather datawarehouse information\n"); 
	$tmpfatal      = $DBFETCHARRAY($result);
	$FATAL         =$tmpfatal[0];

	// Calculating total dangerous alarms, HARMLESS alarms will not be added, not repeatcounts either.
	$TOTAL=($WARNING + $CRITICAL + $FATAL + $HARMLESS);


$monitoringperm=get_role($USERNAME,$PASSWORD,$HOSTNAME,$TYPE="monitoring");
if($monitoringperm == "") {
         if($USERADMIN != "YES") {
                 continue;
         }
}
echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='20%'>
<th class='aetableheadstyle' colspan='3'>Alarmstatistics in numbers and percent for $HOST_VALUE</th></tr>";

if($HARMLESS > 0 ) {
	$AVEREGE_HARMLESS=intval($HARMLESS / $TOTAL * 100);
} else {
	$AVEREGE_HARMLESS=0;
}
if($WARNING > 0 ) {
	$AVEREGE_WARNING=intval($WARNING / $TOTAL * 100);
} else {
	$AVEREGE_WARNING=0;
}
if($CRITICAL > 0 ) {
	$AVEREGE_CRITICAL=intval($CRITICAL / $TOTAL * 100);
} else {
	$AVEREGE_CRITICAL=0;
}
if($FATAL > 0 ) {
	$AVEREGE_FATAL=intval($FATAL / $TOTAL * 100);
} else {
	$AVEREGE_FATAL=0;
}

echo "
<td class='aetdstyle'>$datawareohouse_info3</td>
<td class='aetdstyle'><b>$HARMLESS</b> st</td>
<td class='aetdstyle'><b>$AVEREGE_HARMLESS</b>%</td>
</tr>

<td class='aetdstyle'>$datawareohouse_info4</td>
<td class='aetdstyle'><b>$WARNING</b> st</td>
<td class='aetdstyle'><b>$AVEREGE_WARNING</b>%</td>
</tr>

<td class='aetdstyle'>$datawareohouse_info5</td>
<td class='aetdstyle'><b>$CRITICAL</b> st</td>
<td class='aetdstyle'><b>$AVEREGE_CRITICAL</b>%</td>
</tr>

<td class='aetdstyle'>$datawareohouse_info6</td>
<td class='aetdstyle'><b>$FATAL</b> st</td>
<td class='aetdstyle'><b>$AVEREGE_FATAL</b>%</td>
</tr>

<td class='aetdstyle'>$datawareohouse_info7</td>
<td class='aetdstyle'><b>$TOTAL</b> st</td>
<td class='aetdstyle'><b>$TOTAL</b> st</td>
</tr>
";

}
echo "
</tr>
</table>
</td>
 <td class='right'></td>
 </tr>
  <tr>
   <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
    <div class='armature2'></div>

   </td>
</tr>
</table>";

?>
