<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: functions.php,v 1.24 2006/10/15 18:11:21 andutt Exp $
//
ob_start();

function what_role_has_user($USERNAME,$PASSWORD) {
//
// The function is returning set rolename for specified user
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

$query     = "select hasrole from andutteye_users where username = '$USERNAME' and password = '$PASSWORD'";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query for function what_role_has_user\n");
$output    = $DBFETCHARRAY($result);

return("$output[0]");

# End of subfunction
}
function check_package_role_permissions($username,$password,$rolename,$packagename,$version,$release,$distribution,$patchlevel) {
//
// The function is checking role permission for a specific managemnt object.
//
include("../config/config.php");
#include("../config/settings.php");
include("../config/dbhandler.php");

$query     = "select seqnr from andutteye_role_permissions where rolename = '$rolename' and aepackage = '$packagename' and aeversion ='$version' and aerelease = '$release' and distribution = '$distribution'";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query for check_package_role_permissions function\n");
$output    = $DBFETCHARRAY($result);

#print "SQL->select seqnr from andutteye_role_permissions where rolename = '$rolename' and aepackage = '$packagename' and aeversion ='$version' and aerelease = '$release' and distribution = '$distribution'\n";
if($output[0] != "") {
	return("$output[0]");
} else {
	return("0");
}

# End of subfunction
}
function verify_lce() {
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

$query="select customercompany,nrlicenses,expiredate,licensekey from andutteye_license where seqnr = '1'";
$result=$DBQUERY($query) or die ("\nFailed to execute SQl-query to check licenses.\n");
$output=$DBFETCHARRAY($result);
$tmp1="$nothing$output[0]$output[1]$output[2]";
$tmp=md5($tmp1);

if("$output[3]" != "$tmp") {
	$STATUS="ERROR%20Supportlicense%20key%20or%20some%20other%20supportlicense%20data%20is%20incorrect.%20Verify%20that%20you%20have%20entered%20the%20correct%20information%20that%20you%20retrived%20in%20your%20supportlicense.";
        header("Location:showstatus.php?STATUS=$STATUS");
	exit;
}
# End of subfunction
}
function get_lce_days() {
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

$query     = "select expiredate from andutteye_license where seqnr = '1'";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query to check licenses.\n");
$output    = $DBFETCHARRAY($result);

$regDate=strtotime("$output[0]"); //will come from DB
$curDate=mktime(); //current UNIX timestamp.
$diff= $regDate - $curDate; //date diff in seconds
$diff = $diff / 86400; //date diff in days
$round=round($diff);
return("$round");
# End of subfunction
}
function get_lce_numbers() {
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

$query     = "select nrlicenses from andutteye_license where seqnr = '1'";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query to check licenses.\n");
$output    = $DBFETCHARRAY($result);

return("$output[0]");
# End of subfunction
}
function verify_lce_days() {
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

$query     = "select expiredate from andutteye_license where seqnr = '1'";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query to check licenses.\n");
$output    = $DBFETCHARRAY($result);

$regDate=strtotime("$output[0]"); //will come from DB
$curDate=mktime(); //current UNIX timestamp.
$diff= $regDate - $curDate; //date diff in seconds
$diff = $diff / 86400; //date diff in days
$round=round($diff);

if("$round" < "0") {
	$STATUS="ERROR%20Your%20supportlicense%20has%20expired.%20Please%20renew%20your%20supportlicense%20and%20insert%20the%20new%20licensekey%20in%20the%20admin%20sektion.";
        header("Location:showstatus.php?STATUS=$STATUS");
	exit;
}
# End of subfunction
}
function check_file_role_permissions($username,$password,$rolename,$filename,$directory,$location,$distribution,$group1,$group2,$group3,$group4) {
//
// The function is checking role permission for a specific managemnt object.
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

if($group1 == "") {
	$group1sql="and group1 is NULL";
} else {
	$group1sql="and group1 = '$group1'";
}
if($group2 == "") {
	$group2sql="and group2 is NULL";
} else {
	$group2sql="and group2 = '$group2'";
}
if($group3 == "") {
	$group3sql="and group3 is NULL";
} else {
	$group3sql="and group3 = '$group3'";
}
if($group4 == "") {
	$group4sql="and group4 is NULL";
} else {
	$group4sql="and group4 = '$group4'";
}
$query     = "select seqnr from andutteye_role_permissions where rolename = '$rolename' and filename = '$filename' and directory ='$directory' and location = '$location' and distribution = '$distribution' $group1sql $group2sql $group3sql $group4sql";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query for check_file_role_permissions function\n");
$output    = $DBFETCHARRAY($result);

#print "\n\nDEBUG SQL->select seqnr from andutteye_role_permissions where rolename = '$rolename' and filename = '$filename' and directory ='$directory' and location = '$location' and distribution = '$distribution' $group1sql $group2sql $group3sql $group4sql\n";

if($output[0] != "") {
	return("$output[0]");
} else {
	return("0");
}
# End of subfunction
}
function is_user_andutteye_admin($USERNAME,$PASSWORD) {
//
// The function is checking if the user is andutteye admin.
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

$query     = "select isadmin from andutteye_users where username = '$USERNAME'";
$result    = $DBQUERY($query) or die ("\nFailed to execute SQl-query to get user isadmin?\n");

if($useradmin[0] == "") {
	return("NO");
}
return("$useradmin[0]");
# End of subfunction
}
function check_for_not_checked_in_alarm($HOSTNAME) {
//
// Function is controlling not checked in alarms and adding it if nessasary
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
$date = date("20ymd");
$time = date("h");

//Checking that variables are set.
if(!$HOSTNAME){
	$STATUS="ERROR%20no%20hostname%20where%20passed%20to%20functions.";
	header("Location:showstatus.php?STATUS=$STATUS");
	exit;
}
$query3    = "select repeatcount from andutteye_alarm where hostname='$HOSTNAME' and shortinformation = 'Client has not checked in' and  longinformation = 'Client $HOSTNAME has not checked in on the last day. Thats usually means that something have happend with the monitor so its not fully functional or the host is down. Last checkin was date:$HOSTNAME execute /opt/andutteye/bin/andutteyed -monitor -debug=2 manually to get eventual errors on the screen' and hostname = '$HOSTNAME' and status != 'CLOSED'";
$result3   = $DBQUERY($query3) or die ("\nFailed to execute SQl-query\n");
$output   = $DBFETCHARRAY($result3);

if ($output[0] == "") {
$query2    = "insert into andutteye_alarm(hostname,getdate,gettime,shortinformation,longinformation,severity,status,repeatcount) values('$HOSTNAME','$date','$HOSTNAME','Client has not checked in','Client $HOSTNAME has not checked in on the last day. Thats usually means that something have happend with the monitor so its not fully functional or the host is down. Last checkin was date:$HOSTNAME execute /opt/andutteye/bin/andutteyed -monitor -debug=2 manually to get eventual errors on the screen','FATAL','OPEN','1')";
$result2   = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to create heartbeat post\n");

}else {

$query2    = "update andutteye_alarm set repeatcount=($output[0] + 1) where hostname='$HOSTNAME' and shortinformation = 'Client has not checked in' and  longinformation
 = 'Client $HOSTNAME has not checked in on the last day. Thats usually means that something have happend with the monitor so its not fully functional or the host is dow
n. Last checkin was date:$HOSTNAME execute /opt/andutteye/bin/andutteyed -monitor -debug=2 manually to get eventual errors on the screen' and hostname = '$HOSTNAME'";
$result2   = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to update repeatcount\n");
}

//echo "</tr><td>Parameters passed to this page hst->$HOSTNAME</td></tr>";
//echo "</tr><td>Hasrole->$userhasrole Found->$output[0]</td></tr>";
}
?>
