<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: generate_graph.php,v 1.25 2006/10/15 18:12:55 andutt Exp $
//
ob_start();

if(empty($_GET['HOSTNAME'])){
	print "ERROR Didnt get any hostname value to write graphs on\n";
	exit;
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['ORDERBY'])){
	$ORDERBY='seqnr';
}else{
        $ORDERBY = $_GET['ORDERBY'];
        session_register("$ORDERBY");
}
if(empty($_GET['ORDERTYPE'])){
	$ORDERTYPE='asc';
}else{
        $ORDERTYPE = $_GET['ORDERTYPE'];
        session_register("$ORDERTYPE");
}
if(empty($_GET['MAX'])){
	$MAX='10';
}else{
        $MAX = $_GET['MAX'];
        session_register("$MAX");
}
if(empty($_GET['GRAPHTYPE'])){
	$GRAPHTYPE='cpuusage';
}else{
        $GRAPHTYPE = $_GET['GRAPHTYPE'];
        session_register("$GRAPHTYPE");
}
if(empty($_GET['DEBUG'])){
	$DEBUG='NO';
}else{
        $DEBUG = $_GET['DEBUG'];
        session_register("$DEBUG");
}
if(empty($_GET['GRAPHSIZE'])){
        $GRAPHSIZE='900';
}else{
        $GRAPHSIZE = $_GET['GRAPHSIZE'];
        session_register("$GRAPHSIZE");
}
if(empty($_GET['GRAPHHIGHT'])){
        $GRAPHHIGHT='350';
}else{
        $GRAPHHIGHT = $_GET['GRAPHHIGHT'];
        session_register("$GRAPHHIGHT");
}
if(empty($_GET['PLOTTYPE'])){
        $PLOTTYPE='line';
}else{
        $PLOTTYPE = $_GET['PLOTTYPE'];
        session_register("$PLOTTYPE");
}
if(empty($_GET['FILENAME'])){
        $FILENAME='none';
}else{
        $FILENAME = $_GET['FILENAME'];
        session_register("$FILENAME");
}
if(empty($_GET['DIRECTORY'])){
        $DIRECTORY='none';
}else{
        $DIRECTORY = $_GET['DIRECTORY'];
        session_register("$DIRECTORY");
}
if(empty($_GET['DISTRIBUTION'])){
        $DISTRIBUTION='none';
}else{
        $DISTRIBUTION = $_GET['DISTRIBUTION'];
        session_register("$DISTRIBUTION");
}
if(empty($_GET['SHORTINFO'])){
        $SHORTINFO='none';
}else{
        $SHORTINFO = $_GET['SHORTINFO'];
        session_register("$SHORTINFO");
}
if(empty($_GET['GRAPHCOLOR'])){
        $GRAPHCOLOR="FFFFFF";
}else{
        $GRAPHCOLOR = $_GET['GRAPHCOLOR'];
        session_register("$GRAPHCOLOR");
}
if(empty($_GET['GRAPHTEXTCOLOR'])){
        $GRAPHTEXTCOLOR="FFFFFF";
}else{
        $GRAPHTEXTCOLOR = $_GET['GRAPHTEXTCOLOR'];
        session_register("$GRAPHTEXTCOLOR");
}
include("../config/config.php");
include("../config/dbhandler.php");
include("chart.php");

$query1    = "select nrusers,nrfilesystems,nrprocesses,getdate,gettime,cpuusage,swapusage,memusage from andutteye_hoststatistic where hostname = '$HOSTNAME' order by $ORDERBY $ORDERTYPE limit 0,$MAX";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to get graph-hoststatistic\n");

$nr=1;

while ($line = $DBFETCHARRAY($result1, $DBASSOC )) {

if ( $GRAPHTYPE == "cpuusage" ) {
	$CHANGE = preg_replace("/\ +/"," ", $line[$GRAPHTYPE]);
	$CHANGE = preg_replace("/\ +/"," ", $CHANGE);
	$DATA_SPLIT=split(" ", $CHANGE);
	$DATA0[] = intval($DATA_SPLIT[0]);
	$DATA1[] = intval($DATA_SPLIT[1]);
	$DATA2[] = intval($DATA_SPLIT[2]);
	$DATE[]  = $line['getdate'];
	$TIME[]  = $line['gettime'];
	$DATELAST= $line['getdate'];
	$x_title="Cpu usage in %";
	$y_title="Andutteye Surveillance trends";
	$title="Cpu trend of $HOSTNAME from $DATE[0] to $DATELAST";
	$data_names = $DATE;
	$first_data = $DATA0;
	$second_data = $DATA1;
	$third_data = $DATA2;
}
if ( $GRAPHTYPE == "cpuusagethumb" ) {
	$CHANGE = preg_replace("/\ +/"," ", $line['cpuusage']);
	$CHANGE = preg_replace("/\ +/"," ", $CHANGE);
	$DATA_SPLIT=split(" ", $CHANGE);
	$DATA0[] = intval($DATA_SPLIT[0]);
	$DATA1[] = intval($DATA_SPLIT[1]);
	$DATA2[] = intval($DATA_SPLIT[2]);
	$DATE[]  = '';
	$TIME[]  = $line['gettime'];
	$DATELAST= $line['getdate'];
	$x_title="Cpu";
	$y_title="";
	$title="";
	$data_names = $DATE;
	$first_data = $DATA0;
	$second_data = $DATA1;
	$third_data = $DATA2;
}
if ( $GRAPHTYPE == "swapusage" ) {
	$CHANGE = preg_replace("/\ +/"," ", $line[$GRAPHTYPE]);
	$DATA_SPLIT=split(" ", $CHANGE);
	$DATA0[] = intval($DATA_SPLIT[0] /1024);
	$DATA1[] = intval($DATA_SPLIT[1] /1024);
	$DATA2[] = intval($DATA_SPLIT[2] /1024);
	$DATE[]  = $line['getdate'];
	$DATELAST = $line['getdate'];
	$x_title="Swap usage in MB";
	$y_title="Andutteye Surveillance trends";
	$title="Swap trend of $HOSTNAME from $DATE[0] to $DATELAST";
	$data_names = $DATE;
	$first_data = $DATA0;
	$second_data = $DATA1;
	$third_data = $DATA2;
}
if ( $GRAPHTYPE == "swapusagethumb" ) {
	$CHANGE = preg_replace("/\ +/"," ", $line['swapusage']);
	$DATA_SPLIT=split(" ", $CHANGE);
	$DATA0[] = intval($DATA_SPLIT[0] /1024);
	$DATA1[] = intval($DATA_SPLIT[1] /1024);
	$DATA2[] = intval($DATA_SPLIT[2] /1024);
	$DATE[]  = '';
	$DATELAST = $line['getdate'];
	$x_title="Swap";
	$y_title="";
	$title="";
	$data_names = $DATE;
	$first_data = $DATA0;
	$second_data = $DATA1;
	$third_data = $DATA2;
}
if ( $GRAPHTYPE == "memusagethumb" ) {
	$CHANGE = preg_replace("/\ +/"," ", $line['memusage']);
	$DATA_SPLIT=split(" ", $CHANGE);
	$DATA0[] = intval($DATA_SPLIT[1] /1024);
	$DATA1[] = intval($DATA_SPLIT[2] /1024);
	$DATA2[] = intval($DATA_SPLIT[3] /1024);
	$DATE[]  = '';
	$DATELAST = $line['getdate'];
	$x_title="Mem";
	$y_title="";
	$title="";
	$data_names = $DATE;
	$first_data = $DATA0;
	$second_data = $DATA1;
	$third_data = $DATA2;
}
if ( $GRAPHTYPE == "memusage" ) {
	$CHANGE = preg_replace("/\ +/"," ", $line[$GRAPHTYPE]);
	$DATA_SPLIT=split(" ", $CHANGE);
	$DATA0[] = intval($DATA_SPLIT[1] /1024);
	$DATA1[] = intval($DATA_SPLIT[2] /1024);
	$DATA2[] = intval($DATA_SPLIT[3] /1024);
	$DATE[]  = $line['getdate'];
	$DATELAST = $line['getdate'];
	$x_title="Memory usage in MB";
	$y_title="Andutteye Surveillance trends";
	$title="Memory trend of $HOSTNAME from $DATE[0] to $DATELAST";
	$data_names = $DATE;
	$first_data = $DATA0;
	$second_data = $DATA1;
	$third_data = $DATA2;
}
if ( $GRAPHTYPE == "nrprocesses" ) {
	$DATA0[] = $line['nrprocesses'];
	$DATA1[] = '0';
	$DATA2[] = '0';
	$DATE[]  = $line['getdate'];
	$DATELAST = $line['getdate'];
	$x_title="Nr of processes";
	$y_title="Andutteye Surveillance trends";
	$title="Nr of active processes of $HOSTNAME from $DATE[0] to $DATELAST";
	$data_names = $DATE;
	$first_data = $DATA0;
}
if ( $GRAPHTYPE == "nrfilesystems" ) {
	$DATA0[] = $line[$GRAPHTYPE];
	$DATA1[] = '0';
	$DATA2[] = '0';
	$DATE[]  = $line['getdate'];
	$DATELAST = $line['getdate'];
	$x_title="Nr of filesystems";
	$y_title="Andutteye Surveillance trends";
	$title="Nr of mounted filesystems on $HOSTNAME from $DATE[0] to $DATELAST";
	$data_names = $DATE;
	$first_data = $DATA0;
}
if ( $GRAPHTYPE == "nrusers" ) {
	$DATA0[] = $line['nrusers'];
	$DATA1[] = '0';
	$DATA2[] = '0';
	$DATE[]  = $line['getdate'];
	$DATELAST = $line['getdate'];
	$x_title="Nr of users";
	$y_title="Andutteye Surveillance trends";
	$title="Nr of active users on $HOSTNAME from $DATE[0] to $DATELAST";
	$data_names = 'Nisse';
	$first_data = 'Kalle';
}

$nr++;
}
if ( $GRAPHTYPE == "nrspecs" ) {

$query2  = "select aeversion,hostname,lastupdatedte,lastupdatedtme from andutteye_man_specification where hostname = '$HOSTNAME' order by seqnr desc limit 0,$MAX";
$result2 = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to get specification data\n");

while ($line = $DBFETCHARRAY($result2, $DBASSOC )) {

if ( $GRAPHTYPE == "nrspecs" ) {
        $DATA0[] = $line['aeversion'];
	$DATA1[] = '0';
	$DATA2[] = '0';
        $DATE[]  = $line['lastupdatedte'];
        $DATELAST = $line['lastupdatedte'];
        $x_title="Save count";
        $y_title="Andutteye Software trends";
        $title="Last 25 updates on $HOSTNAME";
        $first_data = $DATA0;
}
// End of while loop.
}
}
if ( $GRAPHTYPE == "nrfiles" ) {

$query3  = "select aeversion,filename,dte,tme from andutteye_man_files where filename = '$FILENAME' and directory = '$DIRECTORY' and distribution = '$DISTRIBUTION' order by seqnr desc limit 0,$MAX";
$result3 = $DBQUERY($query3) or die ("\nFailed to execute SQl-query to get files data\n");

while ($line = $DBFETCHARRAY($result3, $DBASSOC )) {

if ( $GRAPHTYPE == "nrfiles" ) {
        $DATA0[] = $line['aeversion'];
	$DATA1[] = '0';
	$DATA2[] = '0';
        $DATE[]  = $line['dte'];
        $DATELAST = $line['dte'];
        $x_title="Save count";
        $y_title="Andutteye Software trends";
        $title="Last 25 updates on file $FILENAME";
        $first_data = $DATA0;
}
// End of while loop.
}
}
if ( $GRAPHTYPE == "alarm" ) {

$query4  = "select getdate,gettime,repeatcount from andutteye_alarm where hostname = '$HOSTNAME' and  shortinformation = '$SHORTINFO' order by seqnr desc limit 0,$MAX";
$result4 = $DBQUERY($query4) or die ("\nFailed to execute SQl-query to get alarm data\n");

while ($line = $DBFETCHARRAY($result4, $DBASSOC )) {

if ( $GRAPHTYPE == "alarm" ) {
        $DATA0[] = ($line['repeatcount'] + 1);
	$DATA1[] = '0';
	$DATA2[] = '0';
        $DATE[]  = $line['getdate'];
        $DATELAST = $line['getdate'];
        $x_title="Repeatcount";
        $y_title="Andutteye Software trends";
        $title="Last 100 trends for this alarm";
        $first_data = $DATA0;
}
// End of while loop.
}
}
if ( $GRAPHTYPE == "manserver" ) {

$query5  = "select distinct dte from andutteye_man_serverlog order by seqnr desc limit 0,$MAX";
$result5 = $DBQUERY($query5) or die ("\nFailed to execute SQl-query to get alarm data\n");

while ($line = $DBFETCHARRAY($result5, $DBASSOC )) {

if ( $GRAPHTYPE == "manserver" ) {
	$dte = $line['dte'];
	$query6  = "select count(log) from andutteye_man_serverlog where dte = '$dte'";
	$result6 = $DBQUERY($query6) or die ("\nFailed to execute SQl-query\n");
	$output  = $DBFETCHARRAY($result6);

        $DATA0[] = $output[0];
	$DATA1[] = '0';
	$DATA2[] = '0';
        $DATE[]  = $line['dte'];
        $DATELAST = $line['dte'];
        $x_title="Requests served";
        $y_title="Andutteye Software trends";
        $title="Management server throughput the last $MAX days.";
        $first_data = $DATA0;
}
// End of while loop.
}
}
if ( $GRAPHTYPE == "monserver" ) {

$query7  = "select distinct getdate from andutteye_serverlog order by seqnr desc limit 0,$MAX";
$result7 = $DBQUERY($query7) or die ("\nFailed to execute SQl-query to get alarm data\n");

while ($line = $DBFETCHARRAY($result7, $DBASSOC )) {

if ( $GRAPHTYPE == "monserver" ) {
	$getdate = $line['getdate'];
	$query8  = "select count(logentry) from andutteye_serverlog where getdate = '$getdate'";
	$result8 = $DBQUERY($query8) or die ("\nFailed to execute SQl-query\n");
	$output  = $DBFETCHARRAY($result8);

        $DATA0[] = $output[0];
	$DATA1[] = '0';
	$DATA2[] = '0';
        $DATE[]  = $line['getdate'];
        $DATELAST = $line['getdate'];
        $x_title="Requests served";
        $y_title="Andutteye Software trends";
        $title="Monitoring server throughput the last $MAX days.";
        $first_data = $DATA0;
}
// End of while loop.
}
}
if ( $GRAPHTYPE == "syslogserver" ) {

$query8  = "select distinct getdate from andutteye_syslogmessages order by seqnr desc limit 0,$MAX";
$result8 = $DBQUERY($query8) or die ("\nFailed to execute SQl-query to get alarm data\n");

while ($line = $DBFETCHARRAY($result8, $DBASSOC )) {

if ( $GRAPHTYPE == "syslogserver" ) {
	$getdate = $line['getdate'];
	$query9  = "select count(seqnr) from andutteye_syslogmessages where getdate = '$getdate'";
	$result9 = $DBQUERY($query9) or die ("\nFailed to execute SQl-query\n");
	$output  = $DBFETCHARRAY($result9);

        $DATA0[] = $output[0];
	$DATA1[] = '0';
	$DATA2[] = '0';
        $DATE[]  = $line['getdate'];
        $DATELAST = $line['getdate'];
        $x_title="Requests served";
        $y_title="Andutteye Software trends";
        $title="Syslog server throughput the last $MAX days.";
        $first_data = $DATA0;
}
// End of while loop.
}
}
$ochart = new chart($GRAPHSIZE,$GRAPHHIGHT,5, "#$GRAPHCOLOR");
$ochart = new chart($GRAPHSIZE,$GRAPHHIGHT,5, "#$GRAPHCOLOR");
$ochart->setTitle("$title","#$GRAPHTEXTCOLOR",2);
$ochart->setPlotArea(SOLID,"#444444", '#dddddd');
$ochart->setFormat(0,',','.');
$ochart->addSeries($DATA0,"$PLOTTYPE",'Series1', SOLID,'#1bbf45', '#0000ff');
$ochart->addSeries($DATA1,"$PLOTTYPE",'Series2', SOLID,'#ec3838', '#0000ff');
$ochart->addSeries($DATA2,"$PLOTTYPE",'Series3', SOLID,'#1008c1', '#0000ff');
$ochart->setXAxis('#1bbf45', SOLID, 1, "Dates");
$ochart->setYAxis("#$GRAPHTEXTCOLOR", SOLID, 2, "$x_title");
$ochart->setLabels($DATE, "#$GRAPHTEXTCOLOR", 1, VERTICAL);
$ochart->setGrid("#bbbbbb", DASHED, "#bbbbbb", DOTTED);
$ochart->plot('');
?>
