<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: prepare_syslogfilter.php,v 1.27 2006/10/16 15:21:48 andutt Exp $
//
session_start();
ob_start;

if(empty($_GET['HOSTNAME'])){
        $HOSTNAME = "EMPTY_HOSTNAME";
        session_register("$HOSTNAME");
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['STATUS'])){
        $STATUS = "NOSTATUS";
        session_register("$STATUS");
}else{
        $STATUS = $_GET['STATUS'];
        session_register("$STATUS");
}
if(empty($_GET['USERNAME'])){
        $USERNAME = "Got_no_username";
        session_register("$USERNAME");
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $PASSWORD = "Got_no_password";
        session_register("$PASSWORD");
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(isset($_GET['DELETE'])){
	$DELETE = $_GET['DELETE'];
        session_register("$DELETE");
}
$TYPE = $_GET['TYPE'];
session_register("$TYPE");

//
// Settings database stuff and userthemes
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");


if ($DELETE) {
$query    = "delete from andutteye_syslogconf where seqnr = '$DELETE'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to delete syslogfilter\n"); 
}

//Executing query based on users input otherwise default settings
if ( $TYPE == "FILTER" ) {
$query    = "select seqnr,message,actionvalue from andutteye_syslogconf where hostnametranslate = '$HOSTNAME' and actiontype = 'FILTER'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather current filters\n"); 
$query1    = "select hostnametranslate,seqnr,message,actionvalue from andutteye_syslogconf where hostnametranslate = 'ALL' and actiontype = 'FILTER'";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to gather current filters\n"); 
} else {
$query    = "select seqnr,message,actionvalue,severity from andutteye_syslogconf where hostnametranslate = '$HOSTNAME' and actiontype = 'ALARM'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to gather current alarms\n"); 
$query1    = "select hostnametranslate,seqnr,message,actionvalue,severity from andutteye_syslogconf where hostnametranslate = 'ALL' and actiontype = 'ALARM'";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to gather current alarms\n"); 
}

// Checking if the user is superadmin
$query5     = "select isadmin from andutteye_users where username = '$USERNAME'";
$result5    = $DBQUERY($query5) or die ("\nFailed to execute SQl-query to get user isadmin?\n");
$useradmin   = $DBFETCHARRAY($result5);
$USERADMIN  = $useradmin[0];

echo "<form method='GET' action='create_syslogfilter.php'>";

echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
  <td class='topleft'>
  <div class='armature1'></div>
   </td>
   <td class='top'></td>
 <td class='topright'></td>
  </tr>
  <tr>
  <td class='left'></td>
 <td class='fill'>";

echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<td class='aetableheadstyle'>$prepare_syslogfilter1</a></td>
<td class='aetableheadstyle'><a href='#'onclick=\"alert('$prepare_syslogfilter2')\">$prepare_syslogfilter3</a></td>";

if ( $TYPE == "ALARM" ) {
echo "
<td class='aetableheadstyle'><a href='#'onclick=\"alert('$prepare_syslogfilter4')\">$prepare_syslogfilter5</a></td>

<td class='aetableheadstyle'><a href='#'onclick=\"alert('$prepare_syslogfilter6')\">$prepare_syslogfilter7</a></td>";
}
echo "<td class='aetableheadstyle'><a href='#'onclick=\"alert('$prepare_syslogfilter8')\">$prepare_syslogfilter9</a></td>";


echo "
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='TYPE' value='$TYPE'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>";

if($USERADMIN == "YES") {
$NR=0;
while ($line = $DBFETCHARRAY($result1, $DBASSOC )) {
	           $SEQNR          = $line["seqnr"];
	           $ORG_MESSAGE    = $line["actionvalue"];
	           $FILTER_MESSAGE = $line["message"];
		   $SEVERITY       = $line["severity"];
		   $HOSTTRANS	   = $line["hostnametranslate"];

echo "
</tr>
<td class='aetdstyle'>$HOSTTRANS</td>
<td class='aetdstyle'>$ORG_MESSAGE</td>";

if ( $TYPE == "ALARM" ) {
echo "
<td class='aetdstyle'>$FILTER_MESSAGE</td>
<td class='aetdstyle'>$SEVERITY</td>
";
}

echo "<td class='aetdstyle'>
<a href='prepare_syslogfilter.php?DELETE=$SEQNR&HOSTNAME=$HOSTTRANS&USERNAME=$USERNAME&PASSWORD=$PASSWORD&TYPE=$TYPE' target='_self' onclick=\"return confirm('Do you really want to delete $TYPE with seqnr $SEQNR for $HOSTTRANS?')\">Delete this entry</a></td>
";
$NR++;
}
}
$NR=0;
while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
	           $SEQNR          = $line["seqnr"];
	           $ORG_MESSAGE    = $line["actionvalue"];
	           $FILTER_MESSAGE = $line["message"];
		   $SEVERITY       = $line["severity"];

echo "
</tr>
<td class='aetdstyle'>$HOSTNAME</td>
<td class='aetdstyle'>$ORG_MESSAGE</td>";

if ( $TYPE == "ALARM" ) {
echo "
<td class='aetdstyle'>$FILTER_MESSAGE</td>
<td class='aetdstyle'>$SEVERITY</td>
";
}

echo "<td class='aetdstyle'> 
<a href='prepare_syslogfilter.php?DELETE=$SEQNR&HOSTNAME=$HOSTTRANS&USERNAME=$USERNAME&PASSWORD=$PASSWORD&TYPE=$TYPE' target='_self' onclick=\"return confirm('Do you really want to delete $TYPE with seqnr $SEQNR for $HOSTTRANS?')\">Delete this entry</a></td>
";
$NR++;
}
echo "<tr>\n";

echo "
<input type='hidden' name='ORIGINALHOSTNAME' value='$HOSTNAME'>
<td class='aetdstyle'>
<select class='selectboxstyle' name='HOSTNAME' style='WIDTH: 150px'>
<option value='$HOSTNAME'> $HOSTNAME";

if($USERADMIN == "YES") {
	echo "<option value='ALL'> Create for all hosts";
}
echo "</select>
</td>

<td class='aetdstyle'>
<input type='text' class='textboxstyle' name='ORGMESSAGE' size='25%' value=''></td>";

if ( $TYPE == "ALARM" ) {
	echo "
	<td class='aetdstyle'>
	<input type='text' class='textboxstyle' name ='FILTERMESSAGE' size='25%' value=''></td>
	<td class='aetdstyle'>
	<select class='selectboxstyle' name='SEVERITY' style='WIDTH: 200px'>
	<option value='HARMLESS'> HARMLESS
	<option value='WARNING'> WARNING
	<option value='CRITICAL'> CRITICAL
	<option value='FATAL'> FATAL
	</td>";

	echo "<td class='aetdstyle'></td>";
} else {
	echo "<td class='aetdstyle'></td>";
}
echo "
</tr>
<td class='aetdstyle' colspan='4'><input class='buttonstyle' type='submit' value='Submit'></td>
</form>
</td>
</tr>
</table>";

echo "
</td>
<td class='right'></td>
 </tr>
   <tr>
   <td class='bottomleft'></td>
  <td class='bottom'></td>
  <td class='bottomright'>
  <div class='armature2'></div>

 </td>
 </tr>
 </table>";
?>
