<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: role_permissions.php,v 1.21 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

$DATE = date("20ymd");
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

if(empty($_GET['USERNAME'])){
	$STATUS = "ERROR%20Didnt%20recive%20any%20username.";
        header("Location:admin.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD&STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
	$STATUS = "ERROR%20Didnt%20recive%20any%20password.";
        header("Location:admin.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD&STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(empty($_GET['ROLENAME'])){
	$STATUS = "ERROR%20Didnt%20recive%20any%20rolename";
        header("Location:admin.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD&STATUS=$STATUS");
        exit;
}else{
        $ROLENAME = $_GET['ROLENAME'];
        session_register("$ROLENAME");
}
if(isset($_GET['ORDERBY'])){
          $ORDERBY = $_GET['ORDERBY'];
          session_register("$ORDERBY");
} else {
          $ORDERBY = 'seqnr';
          session_register("$ORDERBY");
}
if(isset($_GET['SORT'])){
        $SORT  = $_GET['SORT'];
        session_register("$SORT");
} else {
    $SORT = 'desc';
        session_register("$SORT");
}
if($USERNAME != "admin" && $PASSWORD != "$ADMINPASSWORD") {
        $STATUS="Invalid%20username%20or%20password";
        header("Location:showstatus.php?STATUS=$STATUS");
	exit;
}
//Executing query based on users input otherwise default settings
$query    = "select distinct hostname from andutteye_heartbeat order by $ORDERBY $SORT";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to get current hosts\n"); 

$LINES=0;
$NR=0;
echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
  <td class='topleft'>
  <div class='armature1'></div>
   </td>
    <td class='top'></td>
 <td class='topright'></td>
  </tr>
    <tr>
    <td class='left'></td>
 <td class='fill'>";

echo "
<table  class='aetdstyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<th class='aetableheadstyle' colspan='5'>Change role permissions</th></tr>

<th class='aetableheadstyle'>Hostname<a href='user_permissions.php?ORDERBY=hostname&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' >+</a><a href='user_permissions.php?ORDERBY=hostname&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' >-</a></td>

<th class='aetableheadstyle'>Rolename</td>
<th class='aetableheadstyle'>Monitoring permission</td>
<th class='aetableheadstyle'>Management permission</td>
<th class='aetableheadstyle'>Alter permissions</td>
<th class='aetableheadstyle'>Grant fileobject</td>
<th class='aetableheadstyle'>Grant rpmobject</td>
";

while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
           $HST_VALUE = $line["hostname"];
//
// Checking which permissions the user have
//
$query1    = "select monitoring,management,seqnr from andutteye_roles where rolename = '$ROLENAME' and hostname = '$HST_VALUE'";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to get rolepermissions\n");
$perm      = $DBFETCHARRAY($result1);
$MONPERMISSION=$perm[0];
$MANPERMISSION=$perm[1];

if($MONPERMISSION == "1") {
	$MONWORDPERMISSION="Read";
}
elseif($MONPERMISSION == "2" ) {
	$MONWORDPERMISSION="Read-Write";
}
elseif($MONPERMISSION == "3" ) {
	$MONWORDPERMISSION="Read-Write-Delete";
} else {
	$MONWORDPERMISSION="Nothing";
}
if($MANPERMISSION == "1") {
	$MANWORDPERMISSION="Read";
}
elseif($MANPERMISSION == "2" ) {
	$MANWORDPERMISSION="Read-Write";
}
elseif($MANPERMISSION == "3" ) {
	$MANWORDPERMISSION="Read-Write-Delete";
} else {
	$MANWORDPERMISSION="Nothing";
}
echo "
</tr>
<td class='aetdstyle'>$HST_VALUE</td>
<td class='aetdstyle'>$ROLENAME</td>
<td class='aetdstyle'>[ $MONWORDPERMISSION ]</td>
<td class='aetdstyle'>[ $MANWORDPERMISSION ]</td>


<td class='aetdstyle'>
<form method='GET' action='prepare_permission.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HST_VALUE'>
<input type='hidden' name='ROLENAME' value='$ROLENAME'>
<input class='buttonstyle' type='submit' value='Change permissions'>
</form>
</td>

<td class='aetdstyle'>
<form method='GET' action='prepare_grantfileobject.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='ROLENAME' value='$ROLENAME'>
<input type='hidden' name='HOSTNAME' value='$HST_VALUE'>
<input class='buttonstyle' type='submit' value='Grant fileobject'>
</form>
</td>

<td class='aetdstyle'>
<form method='GET' action='prepare_grantrpmobject.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='ROLENAME' value='$ROLENAME'>
<input type='hidden' name='HOSTNAME' value='$HST_VALUE'>
<input class='buttonstyle' type='submit' value='Grant rpmobject'>
</form>
</td>
";
$NR++;
}

echo "<tr>
        <td class='aetdstyle' colspan='6'>
	<form method='GET' action='admin.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input class='buttonstyle' type='submit' value='Back'>
        </form>
        </td>";

echo "
</td>
</tr>
</table>";

echo "
</td>
<td class='right'></td>
 </tr>
   <tr>
  <td class='bottomleft'></td>
  <td class='bottom'></td>
    <td class='bottomright'>
   <div class='armature2'></div>

 </td>
 </tr>
</table>";

?>
