<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: theme.php,v 1.18 2006/10/15 16:59:27 andutt Exp $
//
/* 
Shall we use images or not, if set to NO the menubar will use text instead of images. If set to YES folowing files are 
needed in the theme directory.

activealarms.png
alarms.png
alarmstats.png
bestuptime.png
block.png
closedalarms.png
config.png
freezedalarms.png
graphtrends.png
head1.png
head2.png
heartbeat.png
home.png
information.png
last.png*
logout.png
minus.png*
monitorview.png
nodestats.png
overview.png
plus.png*
reports.png
serverlog.png
snapshots.png
softwares.png
syslog.png

Following pictures are needed and are used if you are trying to create round tables.

block.png
fill.png
xblock.png
yblock.png
*/
$USEIMAGES="NO";
$GRAPHCOLOR="000000";
$GRAPHTEXTCOLOR="FFFFFF";

echo "
<style>
body {
        background-color: #000000;
        color: #FFFFFF;
}
body,
td {
        font-family: Verdana, Arial, Helvetica, sans-serif;
        font-size : 11px;
}
a:link       {
        color: #564D79;
        text-align : center;
}
a:hover      {
        color: red;
        text-align : center;
}
a:visited      {
        color: #FFFFFF;
        text-align : center;
}
.blink      {
	background: #FFFFFF;
        text-decoration: blink;
        color: #000000;
        text-align : left;
}
.aebacktablestyle {
	background: #00000;
        margin: 2px;
        padding: 2px;
}
.buttonstyle{
        background-color: #D4D3DE;
        border: #000 1px solid;
        color: #000;
        font: 9px verdana, tahoma, arial, helvetica, sans-serif;
        text-align:center;
}
.selectboxstyle{
        background-color: #EFEFEF;
        border: #000 1px solid;
        color: #000;
        font: 9px verdana, tahoma, arial, helvetica, sans-serif;
        text-align:left;
}
.textboxstyle{
        background-color: #EFEFEF;
        border: #000 1px solid;
        color: #000;
        font: 9px verdana, tahoma, arial, helvetica, sans-serif;
        text-align:left;
}
.aetablestyle {
	background: transparent;
        border-top: #FFFFFF 1px solid;
        border-bottom: #FFFFFF 1px solid;
        border-left: #FFFFFF 1px solid;
        border-right: #FFFFFF 1px solid;
        border:  #FFFFFF 1px lined;
        margin: 2px;
        padding: 2px;
}
.aetableheadstyle {
         background: transparent url(../themes/andutteye-black/header.gif) repeat-x;
         color: #000000;
         font-family: Verdana, Arial, Helvetica, sans-serif;
         font-size : 12px;
         text-decoration: underlined;
         margin-left   : 1px;
         margin-right  : 1px;
         text-align : left;

}
.aetdstyle {
         background-color: transparent;
         color: #FFFFFF;
         font-family: Verdana, Arial, Helvetica, sans-serif;
         font-size : 11px;
         font-color: #6d6ac2;
}
.aetdmenustyle {
         background-color: transparent;
         color: #FFFFFF;
         font-family: Verdana, Arial, Helvetica, sans-serif;
         font-size : 12;
         font-color: #6d6ac2;
	 width: 20px;
         text-align : center;
	 
}
A.aetdmenustyle:visited { 
	color: #FFFFFF;
}
A.aetdmenustyle:hover { 
	color: #6d6ac2;
}
A.aetdmenustyle:link { 
	color: #FFFFFF;
}
.aealarmtd {
         background-color: #FFFFFF;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-bottom: #6d6ac2 1px solid;
}
.aetdharmless {
         background-color: #CCFFCC;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
}
.aetdwarning {
         background-color: #FFCC66;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
}
.aetdcritical {
         background-color: #FF6666;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
}
.aetdfatal {
         background-color: #C3C5B7;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
}
.aetdacknowledge {
         background-color: #B0C4DE;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-bottom: #6d6ac2 1px solid;
}
h3 {
        color: #FD5D6C;
        font-family: Verdana, Helvetica, sans-serif;
        font-size : 11px;

}
</style>";
?>
