<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: change_specification.php,v 1.21 2006/10/15 16:59:27 andutt Exp $
//
session_start();
ob_start;

if(empty($_GET['USERNAME'])){
        $STATUS="Got%20no%20username%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $STATUS="Got%20no%20password%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
$HOSTNAME = $_GET['HOSTNAME'];

if(empty($_GET['distribution'])){
        $STATUS="Got%20no%20distribution%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $distribution = $_GET['distribution'];
        session_register("$distribution");
}
$patchlevel = $_GET['patchlevel'];
session_register("$patchlevel");
if(empty($_GET['aegroup'])){
        $STATUS="Got%20no%20aegroup%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $aegroup = $_GET['aegroup'];
        session_register("$aegroup");
}
if(empty($_GET['location'])){
        $STATUS="Got%20no%20location%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $location = $_GET['location'];
        session_register("$location");
}
if(empty($_GET['archtype'])){
        $STATUS="Got%20no%20archtype%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $archtype = $_GET['archtype'];
        session_register("$archtype");
}
if(empty($_GET['description'])){
        $STATUS="Got%20no%20description%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $description = $_GET['description'];
        session_register("$description");
}
if(empty($_GET['status'])){
        $STATUS="Got%20no%20dstatus%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $status = $_GET['status'];
        session_register("$status");
}
$packages = $_GET['packages'];
session_register("$packages");
$bundles = $_GET['bundles'];
session_register("$bundles");

$email = $_GET['email'];
session_register("$email");
if(empty($_GET['allowrpmupdate'])){
        $STATUS="Got%20no%20allowrpmupdate%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $allowrpmupdate = $_GET['allowrpmupdate'];
        session_register("$allowrpmupdate");
}

$allowconfigupdate = $_GET['allowconfigupdate'];
session_register("$allowconfigupdate");

$allowsyslog = $_GET['allowsyslog'];
session_register("$allowsyslog");
//
// Settings database stuff and userthemes
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("authenticate_user.php");
include("authenticate_role.php");

$DATE = date("20ymd");
$TIME = date("h:m:s");

$query2    = "select distinct aeversion from andutteye_man_specification where hostname = '$HOSTNAME' order by seqnr desc limit 0,1";
$result2   = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to get distinct versionk data for host $HOSTNAME\n");
$output   = $DBFETCHARRAY($result2);
$VERSION=($output[0] + 1);

$query    = "insert into andutteye_man_specification(hostname,aeversion,distribution,patchlevel,aegroup,location,archtype,description,status,packages,bundles,email,allowrpmupdate,allowconfigupdate,allowsyslog,lastupdatedof,lastupdatedte,lastupdatedtme) values('$HOSTNAME','$VERSION','$distribution','$patchlevel','$aegroup','$location','$archtype','$description','$status','$packages','$bundles','$email','$allowrpmupdate','$allowconfigupdate','$allowsyslog','$USERNAME','$DATE','$TIME')";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to save new specification\n");

$specification_values = array("packagetype:rpm",
			       "distribution:$distribution",
			       "patchlevel:$patchlevel",
			       "group:$aegroup",
			       "location:$location",
			       "archtype:$archtype",
			       "description:$description",
			       "status:$status",
			       "exclude:",
			       "packages:$packages",
			       "bundles:$bundles",
			       "allow-rpmupdate:$allowrpmupdate",
			       "allow-configupdate:$allowconfigupdate",
			       "allow-syslog:$allowsyslog",
			       "email:$email");
$specification = "$andutteyemanagement_location/specifications/$HOSTNAME";

foreach($specification_values as $i) {
		$writevals .= "$i\n";
}
if (is_writable("$specification")) {
   if (!$handle = fopen("$specification", 'w+')) {
                $STATUS="Cannot%20open%20filename%20$specification%20for%20writing.%20";
                header("Location:showstatus.php?STATUS=$STATUS");
                exit;
   }
   if (fwrite($handle, "$writevals") === FALSE) {
                $STATUS="Cannot%20write%20filename%20$specification.";
                header("Location:showstatus.php?STATUS=$STATUS");
                exit;
   }
   fclose($handle);

} else {
        $STATUS="The%20file%20$specification%20is%20not%20writeble.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}
header("Location:show_specification.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD&HOSTNAME=$HOSTNAME");
?>
