<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: list_changes.php,v 1.20 2006/10/15 18:14:27 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
	$STATUS="Got%20no%20username%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
	$STATUS="Got%20no%20password%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(empty($_GET['OFFSET'])){
        $OFFSET = "0";
        session_register("$OFFSET");
}else{
        $OFFSET = $_GET['OFFSET'];
        session_register("$OFFSET");
}
if(empty($_GET['DISTRIBUTION'])){
        $DISTRIBUTION = "Unset";
        session_register("$DISTRIBUTION");
}else{
        $DISTRIBUTION = $_GET['DISTRIBUTION'];
        session_register("$DISTRIBUTION");
}
if(empty($_GET['HOSTNAME'])){
        $HOSTNAME = "0";
        session_register("$HOSTNAME");
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['search'])){
        $search = "0";
        session_register("$search");
}else{
        $search = $_GET['search'];
        session_register("$search");
}
if(empty($_GET['searchon'])){
        $searchon = "0";
        session_register("$searchon");
}else{
        $searchon = $_GET['searchon'];
        session_register("$searchon");
}

include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("functions.php");
verify_lce();
verify_lce_days();


if(!$USERNAME == "guest" && $PASSWORD == "nopassword") {
	//Verifying user
	include("authenticate_user.php");
}
//Executing query based on users input otherwise default settings

if($search == "0") {
	$query    = "select seqnr,hostname,description,crtdte,crttme,username,severity from andutteye_chg_changes order by seqnr desc limit $OFFSET,$SERVERLOG_MAX";
	$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current changes\n"); 
} else {
	$query    = "select seqnr,hostname,description,crtdte,crttme,username,severity from andutteye_chg_changes where $searchon like '%$search%' order by seqnr asc";
	$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current changes\n"); 
}

echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "<th class='aetableheadstyle' colspan='6'>Quick search for changes</th></tr>
<form method='GET' action='list_changes.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'></td>
<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/search.png'></td>

<td class='aetdstyle'>Search on type</td>
<td class='aetdstyle'><select class='selectboxstyle' name='searchon' style='WIDTH: 100'>
<option value='hostname'> Hostname
<option value='alarmid'> Alarmid
<option value='description'> Description
<option value='information'> Information
<option value='solution'> Solution
<option value='workaround'> Workaround
<option value='severity'> Severity
<option value='username'> Created by
<option value='crtdte'> Created date
<option value='crttme'> Created time
</select></td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='search' value=''></td>
<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Search'></td></tr>
</form>
";


echo "
 </td>
 </tr>
 </table>
 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>";
echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<th class='aetableheadstyle' colspan='9'>Current logged changes</th>
</tr>
<td class='aetdstyle'><b>Hostname</b></td>
<td class='aetdstyle'><b>Created date</b></td>
<td class='aetdstyle'><b>Created time</b></td>
<td class='aetdstyle'><b>Description</b></td>
<td class='aetdstyle'><b>Severity</b></td>
<td class='aetdstyle'><b>Created by</b></td>
<td class='aetdstyle'><b>Open change</b></td>
<td class='aetdstyle'><b>Create change</b></td>
</tr>
";

$NR=0;
while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
           $SEQN_VALUE = $line["seqnr"];
           $HOSTNAME = $line["hostname"];
           $CRTDTE = $line["crtdte"];
           $CRTTME = $line["crttme"];
           $CRTUSER = $line["username"];
           $DESC = $line["description"];
           $SEVERITY = $line["severity"];

if ( "$SEVERITY" == "HARMLESS" ){
        $STATUSIMAGE="harmless.png";
}
elseif ( "$SEVERITY" == "WARNING" ){
        $STATUSIMAGE="warning.png";
}
elseif ( "$SEVERITY" == "CRITICAL" ){
        $STATUSIMAGE="critical.png";
}
elseif ( "$SEVERITY" == "FATAL" ){
        $STATUSIMAGE="fatal.png";
}
elseif ( "$STAT_VALUE" == "ACK" ){
        $STATUSIMAGE="acknowledge.png";
} else {
        $STATUSIMAGE="pending.png";
}
	
echo "
<td class='aetdstyle'>$HOSTNAME</td>
<td class='aetdstyle'>$CRTDTE</td>
<td class='aetdstyle'>$CRTTME</td>
<td class='aetdstyle'>$DESC</td>
<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/$STATUSIMAGE'></img></td>
<td class='aetdstyle'>$CRTUSER</td>

<form method='GET' action='open_changes.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
<input type='hidden' name='CHANGEID' value='$SEQN_VALUE'>
<input type='hidden' name='type' value='open'>
<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Open'></td>
</form>

<form method='GET' action='open_changes.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
<input type='hidden' name='CHANGEID' value='New change'>
<input type='hidden' name='type' value='new'>
<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Create'></td></tr>
</form>
";


$NR++;
}

if($NR == 0) {
echo "
<form method='GET' action='open_changes.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
<input type='hidden' name='CHANGEID' value='New change'>
<input type='hidden' name='type' value='new'>
<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Create new change event'></td></tr>
</form>";
}
$NEXTOFFSET=($OFFSET + 100);
$PRIOROFFSET=($OFFSET - 100);
if($OFFSET > 0 ) {
   echo "<td class='aetdstyle'>
	 <form method='GET' action='list_changes.php'>
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='OFFSET' value='$PRIOROFFSET'>
        <input class='buttonstyle' type='submit' value='Prev page'>
	</form>
	 <form method='GET' action='list_changes.php'>
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
        <input class='buttonstyle' type='submit' value='Next page'>
	</form>
	</td>
	</tr>
	";
} else {
   	echo "<td class='aetdstyle'>
	 <form method='GET' action='list_changes.php'>
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
        <input class='buttonstyle' type='submit' value='Next page'>
	</form>
	</td>
	</tr>
	";
}

echo "
</td>
</tr>
</table>";

if ( $NR == 0 ) {
echo "
 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>
 </table>";
}
echo "
 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>
 </table>";
?>
