<?php
//
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: main.php,v 1.29 2006/10/16 15:11:14 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
        $USERNAME = "Got_no_username";
        session_register("$USERNAME");
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $PASSWORD = "Got_no_password";
        session_register("$PASSWORD");
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
include("../config/settings.php");
include("../config/config.php");
include("../config/dbhandler.php");
include("functions.php");

if($USERNAME != "guest" && $PASSWORD != "nopassword") {
       //Verifying user
       include("authenticate_user.php");
}
$DATE = date("20ymd");
session_register("$DATE");

$query    = "select count(*) from andutteye_alarm where status = 'OPEN'";
$result   = $DBQUERY($query) or die ("\nFailed to get number of active alarms\n");
$NRACTIVEALARMS = $DBFETCHARRAY($result);

$query    = "select count(*) from andutteye_alarm where status = 'FREEZE'";
$result   = $DBQUERY($query) or die ("\nFailed to get number of freezed alarms\n");
$NRFREEZEDALARMS = $DBFETCHARRAY($result);

$query    = "select count(*) from andutteye_alarm where status = 'CLOSED'";
$result   = $DBQUERY($query) or die ("\nFailed to get number of closed alarms\n");
$NRCLOSEDALARMS = $DBFETCHARRAY($result);

$query    = "select count(*) from andutteye_heartbeat where getdate != '$DATE'";
$result   = $DBQUERY($query) or die ("\nFailed to get not checkedin nodes.\n");
$NRNOTCHECKEDIN = $DBFETCHARRAY($result);

$query    = "select count(*) from andutteye_heartbeat";
$result   = $DBQUERY($query) or die ("\nFailed toi get nodes.\n");
$NRCHECKEDIN = $DBFETCHARRAY($result);

$query    = "select ldloggedin,ltloggedin,nrloggedin,hasrole from andutteye_users where username = '$USERNAME'";
$result   = $DBQUERY($query) or die ("\nFailed to get userstats..\n");
$USERSTATS = $DBFETCHARRAY($result);

$query    = "select server from andutteye_config where seqnr = '1'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to get this host.\n");
$THISNODE = $DBFETCHARRAY($result);

$DAYSLEFT=get_lce_days();

$LOADERSTATUS=`ps -efl | grep perl | grep andutteye_server |grep -v grep`;
$SYSLOGSTATUS=`ps -efl | grep perl | grep andutteye_syslog |grep -v grep`;

if($LOADERSTATUS == "") {
	$LOADERSTATUS="<img src='../themes/$USERTHEME/icons/bigminus.png'>";
} else {
	$LOADERSTATUS="<img src='../themes/$USERTHEME/icons/bigplus.png'>";
}
if($SYSLOGSTATUS == "") {
	$SYSLOGSTATUS="<img src='../themes/$USERTHEME/icons/bigminus.png'>";
} else {
	$SYSLOGSTATUS="<img src='../themes/$USERTHEME/icons/bigplus.png'>";
}


echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
    <td class='topleft'>
          <div class='armature1'></div>
    </td>
        <td class='top'></td>
            <td class='topright'></td>
        </tr>
        <tr>
       <td class='left'></td>
       <td class='fill'>

<table border='0' width='100%' align='middle' cellspacing='3' cellpadding='3' class='aetablestyle'>
<th class='aetableheadstyle' colspan='2'>Andutteye Software interface</th></tr>

<td align='left' valign='middle' width='50%' class='aetdstyle'>Logged in with user</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$USERNAME</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Last day and timelogged in</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$USERSTATS[0] $USERSTATS[1]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Number of times logged in</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$USERSTATS[2]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>User have userrole</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$USERSTATS[3]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Choosen usertheme</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$USERTHEME</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Andutteye admin approved</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$USERADMIN</b></td>
</tr>";

if($DAYSLEFT < "10") {
	echo "<td align='left' valign='middle' width='50%' class='aetdstyle'>Days remaining of supportlicense</td>
	<td align='left' valign='middle' width='50%' class='blink'><b>Its only $DAYSLEFT days left before the supportlicense expires.</b></td>
	</tr>";
} else {
	echo "<td align='left' valign='middle' width='50%' class='aetdstyle'>Days remaining of supportlicense</td>
	<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$DAYSLEFT</b></td>
	</tr>";
}
echo "
<td align='left' valign='middle' width='50%' class='aetdstyle'>Number of alarms with status open</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$NRACTIVEALARMS[0]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Number of alarms with status freezed</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$NRFREEZEDALARMS[0]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Number of alarms with status closed</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$NRCLOSEDALARMS[0]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Number nodes that have not checked in today.</td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><b>$NRNOTCHECKEDIN[0]/$NRCHECKEDIN[0]</b></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Andutteye server status.</b></td>
<td align='left' valign='middle' width='50%' class='aetdstyle'>$LOADERSTATUS</td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Andutteye syslog server status.</b></td>
<td align='left' valign='middle' width='50%' class='aetdstyle'>$SYSLOGSTATUS</td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Andutteye documentation.</b></td>
<td align='left' valign='middle' width='50%' class='aetdstyle'>
<a href='http://www.andutteye.com/docs/AndutteyeSoftwareSuitedocumentation.pdf' target'_new'>Andutteye Software Suite documentation</a>
</td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Information, Licenses, Professional support.</b></td>
<td align='left' valign='middle' width='50%' class='aetdstyle'>
<a href='http://www.andutteye.com' target'_new'>www.andutteye.com</a></td>
</tr>
<td align='left' valign='middle' width='50%' class='aetdstyle'>Andutteye Software RSS syndication.</b></td>
<td align='left' valign='middle' width='50%' class='aetdstyle'><a href='http://$THISNODE[0]/andutteye/pages/rss.php'><img src='../themes/andutteye-default/icons/rss.png'></a></td>
</tr>";

if( "$USERNAME" == "admin" ) {
     if($PASSWORD == $ADMINPASSWORD) {
		echo "
		<td class='aetdstyle'><b>Adminstatus granted</b></td>
		<td class='blink'><b><a href='admin.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD'>Administrate Andutteye Software Suite</a></b></td>
		</tr>";
     }
}
echo "
</td>
</tr>
</table>";

if($USERNAME != "guest" && $PASSWORD != "nopassword") {

echo "
<table width='100%' border='0' cellspacing='3' cellpadding='3' align='middle' class='aetablestyle'>
<th class='aetableheadstyle' colspan='4'>Account settings</th></tr>

      <form method='GET' action='change_password.php'>
      <input type='hidden' name='CREATEUSERNAME' value='$USERNAME'>
      <input type='hidden' name='USERNAME' value='$USERNAME'>
      <input type='hidden' name='PASSWORD' value='$PASSWORD'>
      <input type='hidden' name='USERROLE' value='$USERSTATS[3]'>
      <td class='aetdstyle'>Change account password</td>
      <td class='aetdstyle'><input class='textboxstyle' type='password' size='29' name='CREATEPASSWORD1' value''></td>
      <td class='aetdstyle'><input class='textboxstyle' type='password' size='29' name='CREATEPASSWORD2' value''></td>
      <td class='aetdstyle'><input class='buttonstyle' type='submit' value='Change'></td>
      </form>
      </tr>

      <form method='GET' action='change_usertheme.php'>
      <input type='hidden' name='USERNAME' value='$USERNAME'>
      <input type='hidden' name='PASSWORD' value='$PASSWORD'>
      <input type='hidden' name='CREATEUSER' value='$USERNAME'>
      <input type='hidden' name='USERROLE' value='$USERSTATS[3]'>
      <td class='aetdstyle'>Change account theme</td>
      <td class='aetdstyle' colspan='2'><select class='selectboxstyle' name='CRTUSERTHEME' style='WIDTH: 158px'>
      ";

      $command   = `ls ../themes`;
      $themedirs = explode ("\n", $command);

      foreach($themedirs as $i) {
	     echo "<option value='$i'> $i";
      }
      echo "
      </select>
      </td>
      <td class='aetdstyle'><input class='buttonstyle' type='submit' value='Change'></td>
      </form>
      <tr>
      </tr>
      
</td>
</tr>
</table";


echo "
</td>
   <td class='right'></td>
   </tr>
   <tr>
   <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
	<div class='armature2'></div>

</td>
</tr>
</table>";

} else {
echo "
</td>
   <td class='right'></td>
   </tr>
   <tr>
   <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
	<div class='armature2'></div>

</td>
</tr>
</table>";
}

echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
    <td class='topleft'>
          <div class='armature1'></div>
    </td>
        <td class='top'></td>
            <td class='topright'></td>
        </tr>
        <tr>
       <td class='left'></td>
       <td class='fill'>



<table width='100%' border='0' cellspacing='3' cellpadding='3' align='middle' class='aetablestyle'>
<th class='aetableheadstyle' colspan='4'>Andutteye software interface gives you total control.</th></tr>

<td class='aetdstyle'>

</br><h3><li>Andutteye softwares products have many smart features that will help you to manage mange you whole IT infrastructure as a single entity</li></h3>

Andutteye softwares have products that will help you to keep your enterprise environment in control. Andutteye keeps an eye on system recources and alert administrators if any monitor is triggered and can take counter actions to prevent failures before they appear. Management software storing, packeging and implementation for your whole IT infrastructure
</br>
</br>
Andutteye Surveillance will let you manage all aspects of the IT infrastructure,helping to ensure their availability and optimizing their performance. These solutions empower you to manage Linux and the rest of your infrastructure as a service, offering auto-management capabilities and enabling the implementation of a service-oriented architecture. Andutteye make it easier to support and maintain your entire enterprise as a single entity.
</br>
</br>
Andutteye softwares have many many smart features. Take a look under the feature article for a complete list of features. 
</br>
</br>

</td>
</tr>

</td>
</tr>
</table>
";
echo "
</td>
   <td class='right'></td>
   </tr>
   <tr>
   <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
	<div class='armature2'></div>

</td>
</tr>
</table>";

echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
    <td class='topleft'>
          <div class='armature1'></div>
    </td>
        <td class='top'></td>
            <td class='topright'></td>
        </tr>
        <tr>
       <td class='left'></td>
       <td class='fill'>



<table width='100%' border='0' cellspacing='3' cellpadding='3' align='middle' class='aetablestyle'>
<th class='aetableheadstyle' colspan='4'>Linux management and monitoring under the same shell</th></tr>

<td class='aetdstyle'>

</br><h3><li>Andutteyes products gives you automatic deployement and overall monitoring from the same central point.</li></h3>

From version 2.1 Andutteye monitoring (Surveillance) and management are combined in the webinterface. You get complete control from the same central point of operations. With role support you can easaly seperate departments of users and grant the permissions to just the specific object they shall work with.
</br>
</br>

</td>
</tr>
</table>

</td>
   <td class='right'></td>
   </tr>
   <tr>
   <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
	<div class='armature2'></div>
";
?>
