<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: prepare_files.php,v 1.22 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
	$STATUS="Got%20no%20username%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
	$STATUS="Got%20no%20password%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(empty($_GET['OFFSET'])){
        $OFFSET = "0";
        session_register("$OFFSET");
}else{
        $OFFSET = $_GET['OFFSET'];
        session_register("$OFFSET");
}
if(empty($_GET['DISTRIBUTION'])){
        $DISTRIBUTION = "Unset";
        session_register("$DISTRIBUTION");
}else{
        $DISTRIBUTION = $_GET['DISTRIBUTION'];
        session_register("$DISTRIBUTION");
}
if(empty($_GET['HOSTNAME'])){
	$STATUS="Got%20no%20hostname%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['searchdirectory'])){
        $searchdirectory = "";
        session_register("$searchdirectory");
}else{
        $searchdirectory = $_GET['searchdirectory'];
        session_register("$searchdirectory");
}

include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("functions.php");

if(!$USERNAME == "guest" && $PASSWORD == "nopassword") {
	//Verifying user
	include("authenticate_user.php");
}
//Executing query based on users input otherwise default settings
$query    = "select distinct directory from andutteye_man_files";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current file directorys\n"); 

$query1    = "select distinct filename,directory,group1,group2,group2,group4,location,distribution from andutteye_man_files where directory = '$searchdirectory' order by seqnr desc";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to show current file directorys\n"); 

$query2    = "select seqnr,hostname,distribution,patchlevel,aegroup,location,archtype,description,status,packages,bundles,allowrpmupdate,allowconfigupdate,allowsyslog,email,lastupdatedof,lastupdatedte,lastupdatedtme from andutteye_man_specification where hostname = '$HOSTNAME' order by seqnr desc limit 0,1";
$result2   = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to get specification data for host $HOSTNAME \n");
$output    = $DBFETCHARRAY($result2);


echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<th class='aetableheadstyle' colspan='3'>Filerepository management, select a folder ($HOSTNAME)</th>
</tr>
</tr>
";

while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
	   echo "<form method='GET' action='prepare_files.php'>";
           		$directory = $line["directory"];
			echo "
			<input type='hidden' name='USERNAME' value='$USERNAME'></td>
			<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
			<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>
			<input type='hidden' name='searchdirectory' value='$directory'></td>";


			echo "
			<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/dir.png'></td>
			<td class='aetdstyle'><b>$directory</b></td>
			<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Choose'></td></tr>
			</form>";
}

echo "
</td>
</tr>
</table>

 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>
 </table>";

echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<th class='aetableheadstyle' colspan='9'>Select a file to view or change for target directory ($searchdirectory)</th>
</tr>
<td class='aetdstyle'>File</td>
<td class='aetdstyle'>Filename</td>
<td class='aetdstyle'>Directory</td>
<td class='aetdstyle'>Oslocation</td>
<td class='aetdstyle'>Group1</td>
<td class='aetdstyle'>Group2</td>
<td class='aetdstyle'>Group3</td>
<td class='aetdstyle'>Group4</td>
<td class='aetdstyle'>Change</td>
</tr>
";
$useradmin=is_user_andutteye_admin("$USERNAME","$PASSWORD");
$userrole=what_role_has_user("$USERNAME","$PASSWORD");

while ($line = $DBFETCHARRAY($result1, $DBASSOC )) {
	   echo "<form method='GET' action='open_file.php'>";
       		$directory = $line["directory"];
       		$filename = $line["filename"];
       		$location = $line["location"];
       		$distribution = $line["distribution"];
       		$group1 = $line["group1"];
       		$group2 = $line["group2"];
       		$group3 = $line["group3"];
       		$group4 = $line["group4"];

		echo "
		<input type='hidden' name='USERNAME' value='$USERNAME'></td>
		<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
		<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>
		<input type='hidden' name='directory' value='$directory'></td>
		<input type='hidden' name='filename' value='$filename'></td>
		<input type='hidden' name='location' value='$location'></td>
		<input type='hidden' name='group1' value='$group1'></td>
		<input type='hidden' name='group2' value='$group2'></td>
		<input type='hidden' name='group3' value='$group3'></td>
		<input type='hidden' name='group4' value='$group4'></td>
		<input type='hidden' name='distribution' value='$distribution'></td>
		";
			
		$rolepermission=check_file_role_permissions($USERNAME,$PASSWORD,$userrole,$filename,$directory,$location,$distribution,$group1,$group2,$group3,$group4);
		if($rolepermission == "0") {
			if("$useradmin" != "YES") {
				continue;
			}
		}
		echo "
		<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/file.png'></td>
		<td class='aetdstyle'><b>$filename</b></td>
		<td class='aetdstyle'><b>$directory</b></td>
		<td class='aetdstyle'>$location</td>
		<td class='aetdstyle'>$group1</td>
		<td class='aetdstyle'>$group2</td>
		<td class='aetdstyle'>$group3</td>
		<td class='aetdstyle'>$group4</td>
		<td class='aetdstyle'><input type='submit' class='buttonstyle' value='Change'></td></tr>
		</form>";
$NR++;
}

echo "
</td>
</tr>
</table>

 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>
 </table>";
?>
