<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: prepare_packageselection.php,v 1.22 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
	$STATUS="Got%20no%20username%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
	$STATUS="Got%20no%20password%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(empty($_GET['SPECVERSION'])){
	$STATUS="Got%20no%20version%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $SPECVERSION = $_GET['SPECVERSION'];
        session_register("$SPECVERSION");
}
if(empty($_GET['OFFSET'])){
        $OFFSET = "0";
        session_register("$OFFSET");
}else{
        $OFFSET = $_GET['OFFSET'];
        session_register("$OFFSET");
}
if(empty($_GET['DISTRIBUTION'])){
        $DISTRIBUTION = "Unset";
        session_register("$DISTRIBUTION");
}else{
        $DISTRIBUTION = $_GET['DISTRIBUTION'];
        session_register("$DISTRIBUTION");
}
if(empty($_GET['HOSTNAME'])){
        $HOSTNAME = "0";
        session_register("$HOSTNAME");
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['searchpackage'])){
        $searchpackage = "0";
        session_register("$searchpackage");
}else{
        $searchpackage = $_GET['searchpackage'];
        session_register("$searchpackage");
}
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("functions.php");

if(!$USERNAME == "guest" && $PASSWORD == "nopassword") {
	//Verifying user
	include("authenticate_user.php");
}
$useradmin=is_user_andutteye_admin("$USERNAME","$PASSWORD");
$userrole=what_role_has_user("$USERNAME","$PASSWORD");

echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<th class='aetableheadstyle' colspan='6'>Specified package selection</th>
</tr>
<td class='aetdstyle'>Action</td>
<td class='aetdstyle'>Package</td>
<td class='aetdstyle'>Version</td>
<td class='aetdstyle'>Release</td>
<td class='aetdstyle'>Remove</td>
</tr>
";
$query    = "select packages from andutteye_man_specification where hostname = '$HOSTNAME' and aeversion = '$SPECVERSION'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to get specification data for host $HOSTNAME\n");
$output   = $DBFETCHARRAY($result);
$splittedpackages=split(",", $output[0]);
$nr=0;

foreach ($splittedpackages as $i) {
        echo "<form method='GET' action='change_packages.php'>";
        if($i == "") {
                break;
        }
        if (preg_match ("/^\+/", "$i")) {
                        $show="<img src='../themes/$USERTHEME/icons/bigplus.png'>";
                        $style="aetdstyle";
                        $tmp=split("\+", $i);
                        $pkg=split("--",$tmp[1]);
                        $package="$pkg[0]";
                        $version="$pkg[1]";
                        $release="$pkg[2]";
			$aetype="+";
        }
        elseif(preg_match ("/^\-/", "$i")) {
                        $show="<img src='../themes/$USERTHEME/icons/bigminus.png'>";
                        $style="aetdstyle";
			$aetype="-";
			$i = substr("$i", 1);
                        $pkg=split("--",$i);
                        $package="$pkg[0]";
                        $version="$pkg[1]";
                        $release="$pkg[2]";
        } else {
                       $show="Undefined";
                       $style="aetdstyle";
        }
        if($version == "0") {
                       $aeversion="Best version for defined patchlevel";
        } else {
		       $aeversion="$version";
	}
        if($release == "0") {
                       $aerelease="Best release for defined patchlevel";
        } else {
		       $aerelease="$release";
	}
	echo "
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
	<input type='hidden' name='packagename' value='$aetype$package'>
	<input type='hidden' name='version' value='$version'>
	<input type='hidden' name='release' value='$release'>
	<input type='hidden' name='ACTION' value='remove'>
	<input type='hidden' name='actiontype' value='delete'>";

                      echo "<td class='$style'>$show</td>
                      <td class='$style'><b>$package</b></td>
                      <td class='$style'>$aeversion</td>
                      <td class='$style'>$aerelease</td>
		      <td class='$style'><input class='buttonstyle' type='submit' value='Remove'></td>
		      </form>
                      </tr>";
$nr++;
}
echo "
 </td>
 </tr>
 </table>
 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>
 </td>
 </tr>";

echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "<th class='aetableheadstyle' colspan='3'>Quick search package</th></tr>
<form method='GET' action='prepare_packageselection.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'></td>
<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>
<input type='hidden' name='SPECVERSION' value='$SPECVERSION'></td>
<input type='hidden' name='DISTRIBUTION' value='$DISTRIBUTION'></td>
<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/search.png'></td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='searchpackage' value=''></td>
<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Search'></td></tr>
</form>
";


echo "
 </td>
 </tr>
 </table>
 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>";
echo "<table border='0' cellpadding='0' cellspacing='0' width='100%' height='10%' class='aebacktablestyle'>
<td class='topleft'>
  <div class='armature1'></div>
   </td>
      <td class='top'></td>
         <td class='topright'></td>
	  </tr>
	    <tr>
	     <td class='left'></td>
	      <td class='fill'>";

	      echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

if($searchpackage == "0") {
        #$query    = "select aepackage,aeversion,aerelease,distribution,packagetype,location,patchlevel,status,seqnr from andutteye_role_permissions where distribution= '$DISTRIBUTION' and aepackage is not null order by patchlevel desc, aepackage asc limit $OFFSET,100";
        $query    = "select aepackage,aeversion,aerelease,distribution,packagetype,location,patchlevel,status,seqnr from andutteye_man_packages where distribution= '$DISTRIBUTION' and aepackage is not null order by patchlevel desc, aepackage asc limit $OFFSET,100";
        $result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current packages\n");
} else {
        #$query    = "select aepackage,aeversion,aerelease,distribution,packagetype,location,patchlevel,status,seqnr from andutteye_role_permissions where distribution= '$DISTRIBUTION' and aepackage like '%$searchpackage%' and filename is null order by patchlevel desc, aepackage asc limit $OFFSET,100";
        $query    = "select aepackage,aeversion,aerelease,distribution,packagetype,location,patchlevel,status,seqnr from andutteye_man_packages where distribution= '$DISTRIBUTION' and aepackage like '%$searchpackage%' order by patchlevel desc, aepackage asc limit $OFFSET,100";
        $result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current packages\n");
}

echo "
<th class='aetableheadstyle' colspan='9'>Availeble packages</th>
</tr>
<td class='aetdstyle'>Action</td>
<td class='aetdstyle'>Packagetype</td>
<td class='aetdstyle'>Distribution</td>
<td class='aetdstyle'>Package</td>
<td class='aetdstyle'>Version</td>
<td class='aetdstyle'>Release</td>
<td class='aetdstyle'>Patchlevel</td>
<td class='aetdstyle'>Actiontype</td>
<td class='aetdstyle'>Submit</td>
</tr>
";
$NR=0;
while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
	   echo "<form method='GET' action='change_packages.php'>";
           $SEQN_VALUE = $line["seqnr"];
           $PACKAGE = $line["aepackage"];
           $PACKAGETYPE = $line["packagetype"];
           $VERSION = $line["aeversion"];
           $RELEASE = $line["aerelease"];
           $STATUS = $line["status"];
           $DISTRIBUTION = $line["distribution"];
           $PATCHLEVEL = $line["patchlevel"];
           $found="0";

foreach ($splittedpackages as $i) {
        if (preg_match ("/^\+/", "$i")) {
                        $tmp=split("\+", $i);
                        $pkg=split("--",$tmp[1]);
			$aesaction="+";
                        $package="$pkg[0]";
                        $version="$pkg[1]";
                        $release="$pkg[2]";
        }
        elseif(preg_match ("/^\-/", "$i")) {
			$i = substr("$i", 1);
                        $pkg=split("--",$i);
			$aesaction="-";
                        $package="$pkg[0]";
                        $version="$pkg[1]";
                        $release="$pkg[2]";
        } else {
                       $show="Undefined";
                       $style="aetdstyle";
	}
        if("$package" == "$PACKAGE" && "$version" == "$VERSION" && "$release" == "$RELEASE") {
                $found="1";
        }
}
if($found == "1") {
        next;
} else {

	
	   echo "<input type='hidden' name='ACTION' value='add'></td>";
	   echo "<input type='hidden' name='SEQNR' value='SEQN_VALUE'></td>";
	   echo "<input type='hidden' name='USERNAME' value='$USERNAME'></td>";
	   echo "<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>";
	   echo "<input type='hidden' name='packagename' value='$PACKAGE'></td>";
	   echo "<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>";

	   if($STATUS == 'locked') {
		$AECLASS="aetdcritical";
           } else {
		$AECLASS="aetdharmless";
	   }
	   if($PACKAGETYPE == "rpm") {
		$pkgimage="<img src='../themes/$USERTHEME/icons/rpm.png'>";
	   } else {
		$pkgimage="<img src='../themes/$USERTHEME/icons/rpm.png'>";
	   }
	   $rolepermission=check_package_role_permissions($USERNAME,$PASSWORD,$userrole,$PACKAGE,$VERSION,$RELEASE,$DISTRIBUTION,$PATCHLEVEL);
           if($rolepermission == "0") {
                 if("$useradmin" != "YES") {
                           continue;
                 }
           }		
echo "
<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/add.png'></td>
<td class='aetdstyle'>$pkgimage</td>
<td class='aetdstyle'>$DISTRIBUTION</td>
<td class='aetdstyle'><b>$PACKAGE</b></td>";

echo "<td class='aetdstyle'><select class='selectboxstyle' name='version' style='WIDTH: 100'>
<option value='$VERSION'> $VERSION
<option value='0'> Best version for defined patchlevel
</select>
</td>";

echo "<td class='aetdstyle'><select class='selectboxstyle' name='release' style='WIDTH: 100'>
<option value='$RELEASE'> $RELEASE
<option value='0'> Best release for defined patchlevel
</select>
</td>";


echo "
<td class='aetdstyle'>$PATCHLEVEL</td>

<td class='aetdstyle'>
Add<input type='radio' name='actiontype' value='add'>
Delete<input type='radio' name='actiontype' value='remove'>
</td>

<td class='aetdstyle'>
<input class='buttonstyle' type='submit' value='Submit'>
</form>
</td>
</tr>
";
}
$NR++;
}

if($NR == 0) {
	echo "<td class='aetdstyle' align='middle' colspan='9'><b>Didnt find any packages. To be able to work with more packages they must first be granted to your userrole by the Andutteye Software Suite administrator.</b></td></tr>";
}
$NEXTOFFSET=($OFFSET + 100);
$PRIOROFFSET=($OFFSET - 100);
if($OFFSET > 0 ) {
   echo "<td class='aetdstyle'>
	 <form method='GET' action='prepare_packageselection.php'>
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
	<input type='hidden' name='OFFSET' value='$PRIOROFFSET'>
	<input type='hidden' name='DISTRIBUTION' value='$DISTRIBUTION'>
	<input type='hidden' name='SPECVERSION' value='$SPECVERSION'>
        <input class='buttonstyle' type='submit' value='Prev page'>
	</form>
	 <form method='GET' action='prepare_packageselection.php'>
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
	<input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
	<input type='hidden' name='DISTRIBUTION' value='$DISTRIBUTION'>
	<input type='hidden' name='SPECVERSION' value='$SPECVERSION'>
        <input class='buttonstyle' type='submit' value='Next page'>
	</form>
	</td>
	</tr>
	";
} else {
   	echo "<td class='aetdstyle'>
	 <form method='GET' action='prepare_packageselection.php'>
	<input type='hidden' name='USERNAME' value='$USERNAME'>
	<input type='hidden' name='PASSWORD' value='$PASSWORD'>
	<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
	<input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
	<input type='hidden' name='DISTRIBUTION' value='$DISTRIBUTION'>
	<input type='hidden' name='SPECVERSION' value='$SPECVERSION'>
        <input class='buttonstyle' type='submit' value='Next page'>
	</form>
	</td>
	</tr>
	";
}

echo "
</td>
</tr>
</table>

 </td>
     <td class='right'></td>
   </tr>
      <tr>
      <td class='bottomleft'></td>
  <td class='bottom'></td>
     <td class='bottomright'>
        <div class='armature2'></div>

 </td>
 </tr>
 </table>";

?>
