<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: rss.php,v 1.20 2006/10/16 15:21:48 andutt Exp $
//
ob_start();
include("../config/dbhandler.php");

$query    = "select hostname,getdate,gettime,shortinformation,longinformation,repeatcount,severity from andutteye_alarm where status = 'OPEN' order by seqnr desc";
$result   = $DBQUERY($query) or die ("\nFailed to get open alarms\n");

$query1    = "select server from andutteye_config";
$result1   = $DBQUERY($query1) or die ("\nFailed to get server hostname\n");
$output   = $DBFETCHARRAY($result1);

# Print out rss xml header
echo "<?xml version=\"1.0\" encoding=\"1.0\"?>";
echo "<!-- generator=\"Andutteye Software Suite\" -->";
echo "<!-- content type=\"Aes rssfeed\" -->";
echo "<!-- test=\"Andutteye Software Suite is Copyrighted and provided by Thundera. www.thundera.se\" -->";

echo "<rss version='2.0'>";
echo "<channel>";
echo "<title>Andutteye Software suite</title>";
echo "<link>http://www.andutteye.com</link>";
echo "<description>Andutteye management and monitoring status and news</description>";
echo "<language>en-us</language>";
echo "<docs>http://www.andutteye.com</docs>";
echo "<language>en-us</language>";

# Generate open alarms
while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
           $hostname  = $line["hostname"];
           $getdate   = $line["getdate"];
           $gettime   = $line["gettime"];
           $shortinfo = $line["shortinformation"];
           $longinfo  = $line["longinformation"];
           $repcount  = $line["repeatcount"];
           $sev       = $line["severity"];
		# Create XML.
		echo "<item>";
		echo "<title>[ Monitoring ] $hostname $shortinfo.</title>";
		echo "<description>$longinfo. Repeatcount $repcount. Recived $getdate,$gettime. Severity $sev.</description>";
		echo "<link>http://$output[0]/andutteye/index.php</link>";
		echo "</item>\n";
}
# Close channel and rss feed.
echo "</channel>";
echo "</rss>";
echo "</xml>";
?>
