<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: search_syslog.php,v 1.26 2006/10/16 15:21:48 andutt Exp $
//
session_start();
ob_start;

if(empty($_GET['HOSTNAME'])){
        $HOSTNAME = "EMPTY_HOSTNAME";
        session_register("$HOSTNAME");
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['STATUS'])){
        $STATUS = "NOSTATUS";
        session_register("$STATUS");
}else{
        $STATUS = $_GET['STATUS'];
        session_register("$STATUS");
}
if(empty($_GET['USERNAME'])){
        $USERNAME = "Got_no_username";
        session_register("$USERNAME");
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $PASSWORD = "Got_no_password";
        session_register("$PASSWORD");
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(empty($_GET['QUERY'])){
        $QUERY = "NO";
        session_register("$QUERY");
}else{
        $QUERY = $_GET['QUERY'];
        session_register("$QUERY");
}
if(empty($_GET['SEARCHDATE'])){
        $SEARCHDATE = "";
        session_register("$SEARCHDATE");
}else{
        $SEARCHDATE = $_GET['SEARCHDATE'];
        session_register("$SEARCHDATE");
}
if(empty($_GET['SEARCHTIME'])){
        $SEARCHTIME = "";
        session_register("$SEARCHTIME");
}else{
        $SEARCHTIME = $_GET['SEARCHTIME'];
        session_register("$SEARCHTIME");
}
//
// Settings database stuff and userthemes
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");

//Verifying user
include("authenticate_user.php");

//Executing query based on users input otherwise default settings
$query    = "select distinct(hostnametranslate) from andutteye_syslogmessages";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show configuration\n"); 

$query2    = "select distinct hostname from andutteye_hoststatistic order by getdate desc;";
$result2   = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to retrive hostnames\n"); 

echo "<form method='GET' action='search_syslog.php'>";

echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
  <td class='topleft'>
  <div class='armature1'></div>
   </td>
    <td class='top'></td>
<td class='topright'></td>
  </tr>
    <tr>
    <td class='left'></td>
  <td class='fill'>";

if($QUERY == "NO" ) {
echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>
<th class='aetableheadstyle' colspan='3'>Search for syslogmessage</th></tr>
";

echo "
<input type='hidden' name='USERNAME' value='$USERNAME'></td>
<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>";

echo "
<td class='aetdstyle'>Freetext search</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50' name='QUERY' value=''> * This field must have a value.</td></tr>
<td class='aetdstyle'>Specific date</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50' name='SEARCHDATE' value=''> * YYYYMMDD</td></tr>
<td class='aetdstyle'>Specific time</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50' name='SEARCHTIME' value=''> * HH:MM:SS</td></tr>

<td class='aetdstyle'>On hostname</td><td class='aetdstyle'>$HOSTNAME</td></tr>

<td class='aetableheadstyle'>Submit<td class='aetdstyle'><input class='buttonstyle' type='submit' value='$prepare_report29'></td></tr>
</form>
</tr>
</table>";

echo "
</td>
<td class='right'></td>
 </tr>
 <tr>
 <td class='bottomleft'></td>
 <td class='bottom'></td>
  <td class='bottomright'>
     <div class='armature2'></div>

 </td>
 </tr>
 </table>";
 }  else {
$query    = "select seqnr,getdate,gettime,hostname,message from andutteye_syslogmessages where hostnametranslate = '$HOSTNAME' and message like '%$QUERY%' and getdate like '%$SEARCHDATE%' and gettime like '%$SEARCHTIME%'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current syslog messages, are you sure you used a vaild sql statement?\n");
 
echo "
<table class='aebacktablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='100%'>";

echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>";

echo "
<td class='aetableheadstyle'>Action</td>
<td class='aetableheadstyle'>Date</td>
<td class='aetableheadstyle'>Time</td>
<td class='aetableheadstyle'>Hostname</td>
<td class='aetableheadstyle'>Message</td>";

$NR=0;
while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
                  $SEQNR   = $line["seqnr"];
                  $GETDATE = $line["getdate"];
                  $GETTIME = $line["gettime"];
                  $MESSAGE = $line["message"];

echo "
</tr>
<td class='aetdstyle'><a href='search_syslog.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD&HOSTNAME=$HOSTNAME' target='main'>
<img src='../themes/$USERTHEME/icons/act.png' border='0'></a></td>
<td class='aetdstyle'>$GETDATE</td>
<td class='aetdstyle'>$GETTIME</td>
<td class='aetdstyle'>$HOSTNAME</td>
<td class='aetdstyle'>$MESSAGE</td>

";
$NR++;
}
if ( $NR == 0 ) {
echo "</tr>";
}

echo "
</form>
</tr>
</table>";

if ( $NR == 0 ) {
echo "<center>Found no syslogmessages belonging to $HOSTNAME with this searchcriteria.</center>\n";
echo "
</td>
<td class='right'></td>
 </tr>
  <tr>
  <td class='bottomleft'></td>
  <td class='bottom'></td>
    <td class='bottomright'>
    <div class='armature2'></div>

 </td>
 </tr>
</table>";

} else {
echo "
</td>
<td class='right'></td>
 </tr>
  <tr>
  <td class='bottomleft'></td>
  <td class='bottom'></td>
    <td class='bottomright'>
    <div class='armature2'></div>

 </td>
 </tr>
</table>";
}
}
?>
