<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: show_alarms.php,v 1.26 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
        $STATUS="Got%20no%20username%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $STATUS="Got%20no%20password%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
//
// Need username and password to be able to find out users theme.
//
include_once("../config/settings.php");
include_once("../config/config.php");
include_once("../config/dbhandler.php");
include_once("authenticate_role.php");
include_once("functions.php");
verify_lce();
verify_lce_days();

//Setting page style withpages and hover-effects
//And autorefresh in seconds...
echo "
<meta http-equiv='refresh' content='$UPDATE_ALARM_TIME;URL=show_alarms.php?USERNAME=$USERNAME&PASSWORD=$PASSWORD'> 
</meta>
</style>
";

//Registering current date and time.
$DATE = date("20ymd");
$TIME = date("h");
session_register($DATE);
session_register($TIME);

//Setting orderby query so user can sortby tablehead

if(isset($_GET['ORDERBY'])){
	    $ORDERBY = $_GET['ORDERBY'];
		session_register("$ORDERBY");
} else {
	  $ORDERBY = 'seqnr';
	  session_register("$ORDERBY");
}
//Setting sorttype asc/desc
if(isset($_GET['SORT'])){
	$SORT  = $_GET['SORT'];
	session_register("$SORT");
} else {
    $SORT = 'desc';
	session_register("$SORT");
}
if($USERNAME != "guest" && $PASSWORD != "nopassword") {
	//Verifying user
     	include("authenticate_user.php");
}
$useradmin=is_user_andutteye_admin("$USERNAME","$PASSWORD");

//Executing query based on users input otherwise default settings
$query    = "select seqnr,hostname,getdate,gettime,shortinformation,longinformation,repeatcount,status,severity from andutteye_alarm where status != 'CLOSED' and status != 'FREEZE' order by $ORDERBY $SORT";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show our active alarms\n");

$query1    = "select hostname,gettime,getdate,type,status from andutteye_heartbeat";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to select from heartbeattable\n");

$LINES=0;
$NR=0;
while ($line = $DBFETCHARRAY ($result1, $DBASSOC )) {
	$NR++;
	$LINES++;
	$H_HOSTNAME = $line["hostname"];
	$H_GETDATE  = $line["getdate"];
	$H_GETTIME  = $line["gettime"];
	$H_TYPE     = $line["type"];

	if ( "$TIME" != "12" ) {
		if ( "$H_GETDATE" != "$DATE" ) {
			if("$H_HOSTNAME" == "") {
				continue;
			}
			check_for_not_checked_in_alarm("$H_HOSTNAME");
     		}
	}
// End of while loop.
}


echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
  <td class='topleft'>
    <div class='armature1'></div>
   </td>
   <td class='top'></td>
 <td class='topright'></td>
  </tr>
    <tr>
    <td class='left'></td>
   <td class='fill'>";

echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>
<th class='aetableheadstyle' colspan='9'>Open alarms tactical view</th></tr>

<td class='aetableheadstyle'>Action</td>
<td class='aetableheadstyle'>$show_alarms1<a href='show_alarms.php?ORDERBY=seqnr&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b></a><a href='show_alarms.php?ORDERBY=seqnr&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b></a></td>

<td class='aetableheadstyle'>$show_alarms2<a href='show_alarms.php?ORDERBY=hostname&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=hostname&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>

<td class='aetableheadstyle'>$show_alarms3<a href='show_alarms.php?ORDERBY=repeatcount&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=repeatcount&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>

<td class='aetableheadstyle'>$show_alarms4<a href='show_alarms.php?ORDERBY=severity&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=severity&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>

<td class='aetableheadstyle'>$show_alarms5<a href='show_alarms.php?ORDERBY=status&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=status&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>

<td class='aetableheadstyle'>$show_alarms6<a href='show_alarms.php?ORDERBY=shortinformation&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=shortinformation&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>

<td class='aetableheadstyle'>$show_alarms7<a href='show_alarms.php?ORDERBY=getdate&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=getdate&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>

<td class='aetableheadstyle'>$show_alarms8<a href='show_alarms.php?ORDERBY=gettime&SORT=asc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>+</b</a><a href='show_alarms.php?ORDERBY=gettime&SORT=desc&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self' ><b>-</b</a></td>
</tr>
";


$LINES=0;
$NR=0;
while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
	$LINES++;
	$SEQN_VALUE = $line["seqnr"];
	$HOST_VALUE = $line["hostname"];
	$DATE_VALUE = $line["getdate"];
	$TIME_VALUE = $line["gettime"];
	$SMSG_VALUE = $line["shortinformation"];
	$LMSG_VALUE = $line["longinformation"];
	$REPC_VALUE = $line["repeatcount"];
	$STAT_VALUE = $line["status"];
	$SEVE_VALUE = $line["severity"];

	if("$HOST_VALUE" == "") {
		continue;
	}
	$monitoringperm=get_role($USERNAME,$PASSWORD,$HOST_VALUE,$TYPE="monitoring");
        if($monitoringperm == "") {
               if($USERADMIN != "YES") {
                       continue;
               }
        }
	
if ( "$SEVE_VALUE" == "HARMLESS" ){
	$SEVFONTCOL="green";
	$TMPCOLOR="#CCFFCC";
	$AECLASS="aetdharmless";
	$STATUSIMAGE="harmless.png";
}
elseif ( "$SEVE_VALUE" == "WARNING" ){
	$SEVFONTCOL="orange";
	$TMPCOLOR="#FFCC66";
	$AECLASS="aetdwarning";
	$STATUSIMAGE="warning.png";
}
elseif ( "$SEVE_VALUE" == "CRITICAL" ){
	$SEVFONTCOL="red";
	$TMPCOLOR="#FF6666";
	$AECLASS="aetdcritical";
	$STATUSIMAGE="critical.png";
}
elseif ( "$SEVE_VALUE" == "FATAL" ){
	$SEVFONTCOL="#999999";
	$TMPCOLOR="#C3C5B7";
	$AECLASS="aetdfatal";
	$STATUSIMAGE="fatal.png";
} else {
        $SEVFONTCOL="blue";
        $TMPCOLOR="#B0C4DE";
	$AECLASS="aetdnone";
}
if ( "$STAT_VALUE" == "ACK" ){
	$SEVFONTCOL="blue";
	$TMPCOLOR="#B0C4DE";
	$AECLASS="aetdacknowledge";
	$STATUSIMAGE="acknowledge.png";
}
//
// Checking if we should replace short information field with a filtered one.
//_
$query4    = "select hostname,original_message,filter_message from andutteye_filter where hostname = '$HOST_VALUE'";
$result4   = $DBQUERY($query4) or die ("\nFailed to execute SQl-query to verify filters\n");

while ($line = $DBFETCHARRAY($result4, $DBASSOC )) {
	   $FILTERHOST   = $line["hostname"];
	   $FILTERORGMSG = $line["original_message"];
	   $FILTERFRTMSG = $line["filter_message"];
	   $query5    = "select shortinformation from andutteye_alarm where seqnr = '$SEQN_VALUE' and shortinformation like '%$FILTERORGMSG%'";
	   $result5   = $DBQUERY($query5) or die ("\nFailed to execute SQl-query to verify filter-seqnr\n");
	   $check     = $DBFETCHARRAY($result5);
		if($check[0]) {
			$SMSG_VALUE = $FILTERFRTMSG;
		}
}
echo "
<td class='$AECLASS'><a href='showdetailed_info.php?SEQNR=$SEQN_VALUE&USERNAME=$USERNAME&PASSWORD=$PASSWORD' target='_self'>
<img src='../themes/$USERTHEME/icons/act.png' border='0'></a></td>
<td class='$AECLASS'>$SEQN_VALUE</td>
<td class='$AECLASS'>$HOST_VALUE</td>
<td class='$AECLASS'>$REPC_VALUE</td>
<td class='$AECLASS' bgcolor='$SEVFONTCOL'><img src='../themes/$USERTHEME/icons/$STATUSIMAGE'></img></td>
<td class='$AECLASS'>$STAT_VALUE</td>
<td class='$AECLASS' width='40%'>$SMSG_VALUE</td>
<td class='$AECLASS'>$DATE_VALUE</td>
<td class='$AECLASS'>$TIME_VALUE</td>
</tr>
";
$NR++;
}
echo "
</td>
</tr>
</table>";

if ( $NR == 0 ) {
echo "
</td>
<td class='right'></td>
   </tr>
    <tr>
    <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
  <div class='armature2'></div>

</td>
</tr>
</table>";
} else {
echo "
</td>
<td class='right'></td>
   </tr>
    <tr>
    <td class='bottomleft'></td>
   <td class='bottom'></td>
   <td class='bottomright'>
  <div class='armature2'></div>

</td>
</tr>
</table>";
}
?>
