<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: show_manserverlog.php,v 1.21 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
        $USERNAME = "Got_no_username";
        session_register("$USERNAME");
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $PASSWORD = "Got_no_password";
        session_register("$PASSWORD");
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(isset($_GET['ORDERBY'])){
	$ORDERBY = $_GET['ORDERBY'];
	session_register("$ORDERBY");
} else {
        $ORDERBY = 'seqnr';
        session_register("$ORDERBY");
}
if(isset($_GET['SORT'])){
        $SORT  = $_GET['SORT'];
        session_register("$SORT");
} else {
        $SORT = 'desc';
        session_register("$SORT");
}
if(isset($_GET['FILTERVALUE'])){
        $FILTERVALUE  = $_GET['FILTERVALUE'];
        session_register("$FILTERVALUE");
} else {
        $FILTERVALUE = 'NO';
        session_register("$FILTERVALUE");
}
if(isset($_GET['FILTERTYPE'])){
        $FILTERTYPE  = $_GET['FILTERTYPE'];
        session_register("$FILTERTYPE");
} else {
	$FILTERTYPE = 'ALARM';
	session_register("$FILTERTYPE");
}
if(isset($_GET['MAXROWS'])){
        $MAXROWS  = $_GET['MAXROWS'];
        session_register("$MAXROWS");
} else {
	$MAXROWS = '100';
	session_register("$MAXROWS");
}
if(empty($_GET['HOSTNAME'])){
        $HOSTNAME = "DIDNT_GET_ANY_HOSTNAME";
        session_register("$HOSTNAME");
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['OFFSET'])){
        $OFFSET = "0";
        session_register("$OFFSET");
}else{
        $OFFSET = $_GET['OFFSET'];
        session_register("$OFFSET");
}

include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("authenticate_role.php");
include("functions.php");
verify_lce();
verify_lce_days();


$query    = "select configparam from andutteye_webbconfig where configname = 'ALLOWGUESTVIEW'";
$result   = $DBQUERY($query) or die ("\nFailed to get guest allow permissions\n");
$ALLOWGUESTVIEW = $DBFETCHARRAY($result);

if($USERNAME != "guest" && $PASSWORD != "nopassword") {
	     //Verifying user
	     include("authenticate_user.php");
}
echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
 <td class='topleft'>
    <div class='armature1'></div>
      </td>
        <td class='top'></td>
	  <td class='topright'></td>
	    </tr>
	      <tr>
	          <td class='left'></td>
	    <td class='fill'>";

echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>
<th class='aetableheadstyle' colspan='5'>SSH Wrapper worklog</th>
</tr>
<td class='aetdstyle' colspan='5'>
<img src='generate_graph.php?HOSTNAME=$HOSTNAME&GRAPHTYPE=manserver&ORDERBY=seqnr&ORDERTYPE=desc&MAX=30&GRAPHSIZE=800&GRAPHHIGHT=150&PLOTTYPE=line&GRAPHCOLOR=$GRAPHCOLOR&GRAPHTEXTCOLOR=$GRAPHTEXTCOLOR' align='middle' alt='Andutteye software graph' width=`800`></td>
</tr>
";
echo "
<td class='aetableheadstyle'>$show_serverconfig6</td>
<td class='aetableheadstyle'>$show_serverconfig7</td>
<td class='aetableheadstyle'>$show_serverconfig11</td>
<td class='aetableheadstyle'>$show_serverconfig4</td>
<td class='aetableheadstyle'>Log</td>
</tr>";

$query1    = "select seqnr,hostname,aetype,dte,tme,log from andutteye_man_serverlog order by seqnr desc limit $OFFSET,$SERVERLOG_MAX";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to show serverlog information\n"); 

while ($line = $DBFETCHARRAY($result1, $DBASSOC )) {
           $SEQN_VALUE = $line["seqnr"];
           $LOG_VALUE = $line["log"];
           $DATE_VALUE = $line["dte"];
           $TIME_VALUE = $line["tme"];
           $MSG_VALUE = $line["aetype"];
           $HST_VALUE = $line["hostname"];

	   $managementperm=get_role($USERNAME,$PASSWORD,$HST_VALUE,$TYPE="management");
	   if($managementperm == "") {
           	  if($USERADMIN != "YES") {
		 	  continue;
		  }
	   }

echo "
</tr>
<td class='aetdstyle'>$DATE_VALUE</td>
<td class='aetdstyle'>$TIME_VALUE</td>
<td class='aetdstyle'>$MSG_VALUE</td>
<td class='aetdstyle'>$HST_VALUE</td>
<td class='aetdstyle'>$LOG_VALUE</td>
</tr>
";
//End of while
}
$NEXTOFFSET=($OFFSET + $SERVERLOG_MAX);
$PRIOROFFSET=($OFFSET - $SERVERLOG_MAX);

if($OFFSET > 0 ) {
   echo "<td class='aetdstyle'>
         <form method='GET' action='show_manserverlog.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
        <input type='hidden' name='OFFSET' value='$PRIOROFFSET'>
        <input class='buttonstyle' type='submit' value='Prev page'>
        </form>
         <form method='GET' action='show_manserverlog.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
        <input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
        <input class='buttonstyle' type='submit' value='Next page'>
        </form>
        </td>
        </tr>
        ";
} else {
        echo "<td class='aetdstyle'>
         <form method='GET' action='show_manserverlog.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
        <input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
        <input class='buttonstyle' type='submit' value='Next page'>
        </form>
        </td>
        </tr>
        ";
}
echo "
</td>
</tr>
</table>

</td>
<td class='right'></td>
 </tr>
   <tr>
    <td class='bottomleft'></td>
    <td class='bottom'></td>
       <td class='bottomright'>
         <div class='armature2'></div>

	 </td>
	 </tr>
	 </table>";
?>
