<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: show_serverconfig.php,v 1.28 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
        $USERNAME = "Got_no_username";
        session_register("$USERNAME");
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $PASSWORD = "Got_no_password";
        session_register("$PASSWORD");
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
if(isset($_GET['ORDERBY'])){
	$ORDERBY = $_GET['ORDERBY'];
	session_register("$ORDERBY");
} else {
        $ORDERBY = 'seqnr';
        session_register("$ORDERBY");
}
if(isset($_GET['SORT'])){
        $SORT  = $_GET['SORT'];
        session_register("$SORT");
} else {
        $SORT = 'desc';
        session_register("$SORT");
}
if(empty($_GET['HOSTNAME'])){
        $HOSTNAME = "DIDNT_GET_ANY_HOSTNAME";
        session_register("$HOSTNAME");
}else{
        $HOSTNAME = $_GET['HOSTNAME'];
        session_register("$HOSTNAME");
}
if(empty($_GET['OFFSET'])){
        $OFFSET = "0";
        session_register("$OFFSET");
}else{
        $OFFSET = $_GET['OFFSET'];
        session_register("$OFFSET");
}
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("authenticate_role.php");
include("functions.php");
verify_lce();
verify_lce_days();


if($USERNAME != "guest" && $PASSWORD != "nopassword") {
	     //Verifying user
	     include("authenticate_user.php");
}

//Executing query based on users input otherwise default settings
$query    = "select seqnr,server,port,getdate,gettime,type,aeversion,aeversion2 from andutteye_config where seqnr = '1'";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show current configuration\n"); 
$output   = $DBFETCHARRAY($result);

$SEQNR=$output[0];
$HOSTNAME=$output[1];
$PORT=$output[2];
$GETDATE=$output[3];
$GETTIME=$output[4];
$TYPE=$output[5];
$VERSION=$output[6];
$VERSION2=$output[7];

echo "
<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>
 <td class='topleft'>
    <div class='armature1'></div>
      </td>
        <td class='top'></td>
	  <td class='topright'></td>
	    </tr>
	      <tr>
	          <td class='left'></td>
	    <td class='fill'>";

echo "<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>
<th class='aetableheadstyle' colspan='17'>Server information and worklog</th></tr>

<td class='aetdstyle'>$show_serverconfig4</td>
<td class='aetdstyle'>$HOSTNAME</td>
</tr>

<td class='aetdstyle'>$show_serverconfig5</td>
<td class='aetdstyle'>$PORT</td>
</tr>

<td class='aetdstyle'>$show_serverconfig6</td>
<td class='aetdstyle'>$GETDATE</td>
</tr>

<td class='aetdstyle'>$show_serverconfig7</td>
<td class='aetdstyle'>$GETTIME</td>
</tr>

<td class='aetdstyle'>$show_serverconfig10</td>
<td class='aetdstyle' colspan='17'>$VERSION</td>
</tr>

<td class='aetdstyle'>Syslogversion</td>
<td class='aetdstyle' colspan='17'>$VERSION2</td>
</tr>

<td class='aetdstyle' colspan='11'>
<img src='generate_graph.php?HOSTNAME=$HOSTNAME&GRAPHTYPE=monserver&ORDERBY=seqnr&ORDERTYPE=desc&MAX=30&GRAPHSIZE=800&GRAPHHIGHT=150&PLOTTYPE=line&GRAPHCOLOR=$GRAPHCOLOR&GRAPHTEXTCOLOR=$GRAPHTEXTCOLOR' align='middle' alt='Andutteye software graph' width=`800`></td>
</tr>
<td class='aetdstyle' colspan='11'>
<img src='generate_graph.php?HOSTNAME=$HOSTNAME&GRAPHTYPE=syslogserver&ORDERBY=seqnr&ORDERTYPE=desc&MAX=30&GRAPHSIZE=800&GRAPHHIGHT=150&PLOTTYPE=line&GRAPHCOLOR=$GRAPHCOLOR&GRAPHTEXTCOLOR=$GRAPHTEXTCOLOR' align='middle' alt='Andutteye software graph' width=`800`></td>
</tr>
";

$query1    = "select seqnr,logentry,getdate,gettime,messagetype,hostname from andutteye_serverlog order by seqnr desc limit $OFFSET,$SERVERLOG_MAX";
$result1   = $DBQUERY($query1) or die ("\nFailed to execute SQl-query to show serverlog information\n"); 

echo "
<td class='aetableheadstyle'>$show_serverconfig6</td>
<td class='aetableheadstyle'>$show_serverconfig7</td>
<td class='aetableheadstyle'>$show_serverconfig11</td>
<td class='aetableheadstyle'>$show_serverconfig4</td>
<td class='aetableheadstyle' colspan='11'>$show_serverconfig12</td>
";

while ($line = $DBFETCHARRAY($result1, $DBASSOC )) {
           $SEQN_VALUE = $line["seqnr"];
           $LOG_VALUE = $line["logentry"];
           $DATE_VALUE = $line["getdate"];
           $TIME_VALUE = $line["gettime"];
           $MSG_VALUE = $line["messagetype"];
           $HST_VALUE = $line["hostname"];

echo "
</tr>
<td class='aetdstyle'>$DATE_VALUE</a></td>
<td class='aetdstyle'>$TIME_VALUE</a></td>
<td class='aetdstyle'>$MSG_VALUE</a></td>
<td class='aetdstyle'>$HST_VALUE</a></td>
<td class='aetdstyle' colspan='11'>$LOG_VALUE
</td>
</tr>
";

$NR++;
}
$NEXTOFFSET=($OFFSET + $SERVERLOG_MAX);
$PRIOROFFSET=($OFFSET - $SERVERLOG_MAX);

if($OFFSET > 0 ) {
   echo "<td class='aetdstyle'>
         <form method='GET' action='show_serverconfig.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
        <input type='hidden' name='OFFSET' value='$PRIOROFFSET'>
        <input class='buttonstyle' type='submit' value='Prev page'>
        </form>
         <form method='GET' action='show_serverconfig.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
        <input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
        <input class='buttonstyle' type='submit' value='Next page'>
        </form>
        </td>
        </tr>
        ";
} else {
        echo "<td class='aetdstyle'>
         <form method='GET' action='show_serverconfig.php'>
        <input type='hidden' name='USERNAME' value='$USERNAME'>
        <input type='hidden' name='PASSWORD' value='$PASSWORD'>
        <input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
        <input type='hidden' name='OFFSET' value='$NEXTOFFSET'>
        <input class='buttonstyle' type='submit' value='Next page'>
        </form>
        </td>
        </tr>
        ";
}


echo "
</td>
</tr>
</table>";

echo "
</td>
<td class='right'></td>
 </tr>
   <tr>
    <td class='bottomleft'></td>
    <td class='bottom'></td>
       <td class='bottomright'>
         <div class='armature2'></div>

	 </td>
	 </tr>
	 </table>";
?>
