<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: show_specification.php,v 1.25 2006/10/16 15:21:48 andutt Exp $
//
ob_start();

if(empty($_GET['USERNAME'])){
        $STATUS="Got%20no%20username%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $USERNAME = $_GET['USERNAME'];
        session_register("$USERNAME");
}
if(empty($_GET['PASSWORD'])){
        $STATUS="Got%20no%20password%20passed%20to%20this%20page.";
        header("Location:showstatus.php?STATUS=$STATUS");
        exit;
}else{
        $PASSWORD = $_GET['PASSWORD'];
        session_register("$PASSWORD");
}
$HOSTNAME = $_GET['HOSTNAME'];
if(empty($_GET['LOADOLDVERSION'])){
        $LOADOLDVERSION = "";
        session_register("$LOADOLDVERSION");
}else{
        $LOADOLDVERSION = $_GET['LOADOLDVERSION'];
        session_register("$LOADOLDVERSION");
}
if(empty($_GET['DEL'])){
        $DEL = "NO";
        session_register("$DEL");
}else{
        $DEL = $_GET['DEL'];
        session_register("$DEL");
}
//
// Settings database stuff and userthemes
//
include("../config/config.php");
include("../config/settings.php");
include("../config/dbhandler.php");
include("authenticate_user.php");
include("authenticate_role.php");


$managementperm=get_role($USERNAME,$PASSWORD,$HOSTNAME,$TYPE="management");
if($managementperm < 2) {
	$STATUS="You%20must%20have%20management%20write%20permissions%20for%20$HOSTNAME%20to%20be%20able%20to%20access%20this%20section.";
	header("Location:showstatus.php?STATUS=$STATUS&USERNAME=$USERNAME&PASSWORD=$PASSWORD");
	exit;
}

if($DEL != "NO") {
	$query9    = "delete from andutteye_man_specification where hostname = '$HOSTNAME'";
	$result9   = $DBQUERY($query9) or die ("\nFailed to execute SQl-query to delete specification for $HOSTNAME\n");
}
//Executing query based on users input otherwise default settings
if($LOADOLDVERSION == "") {
	$query    = "select seqnr,hostname,distribution,patchlevel,aegroup,location,archtype,description,status,packages,bundles,allowrpmupdate,allowconfigupdate,allowsyslog,email,lastupdatedof,lastupdatedte,lastupdatedtme from andutteye_man_specification where hostname = '$HOSTNAME' order by seqnr desc limit 0,1";
	$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to get specification data for host $HOSTNAME \n");
	$output   = $DBFETCHARRAY($result);
} else {
	$query    = "select seqnr,hostname,distribution,patchlevel,aegroup,location,archtype,description,status,packages,bundles,allowrpmupdate,allowconfigupdate,allowsyslog,email,lastupdatedof,lastupdatedte,lastupdatedtme from andutteye_man_specification where hostname = '$HOSTNAME' and aeversion = '$LOADOLDVERSION'";
	$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to get specification data for host $HOSTNAME and aeversion $LOADOLDVERSION \n");
	$output   = $DBFETCHARRAY($result);
}

$seqnr=$output[0];
$hostname=$output[1];
$distribution=$output[2];
$dist=$output[2];
$patchlevel=$output[3];
$aegroup=$output[4];
$location=$output[5];
$archtype=$output[6];
$description=$output[7];
$status=$output[8];
$packages=$output[9];
$bundles=$output[10];
$allowrpmupdate=$output[11];
$allowconfigupdate=$output[12];
$allowsyslog=$output[13];
$email=$output[14];
$lastupdateof=$output[15];
$lastupdatedte=$output[16];
$lastupdatedtme=$output[17];
$splittedpackages=split(",", $packages);
$splittedbundles=split(",", $bundles);

$query2    = "select distinct aeversion from andutteye_man_specification where hostname = '$HOSTNAME' order by seqnr desc";
$result2   = $DBQUERY($query2) or die ("\nFailed to execute SQl-query to get distinct version data for host $HOSTNAME\n");

$query3    = "select distinct patchlevel from andutteye_man_patchlevel where distribution = '$distribution'";
$result3   = $DBQUERY($query3) or die ("\nFailed to execute SQl-query to get distinct patchlevels for distribution\n");

$query4    = "select distinct distribution from andutteye_man_patchlevel order by distribution asc";
$result4   = $DBQUERY($query4) or die ("\nFailed to execute SQl-query to get distinct distributions\n");

echo "<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>

 <td class='topleft'>
    <div class='armature1'></div>
    </td>
 <td class='top'></td>
  <td class='topright'></td>
  </tr>
  <tr>
    <td class='left'></td>
<td class='fill'>";


echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>
<th class='aetableheadstyle' colspan='4'>Andutteyemanagement specification for $HOSTNAME</th></tr>
</tr><th class='aetableheadstyle' colspan='4'>Core settings</th></tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('In the information field you will get information on who saved the current loaded version and which date and time it was.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Information</td>
<td class='aetdstyle'><b><i>Lastupdated of $lastupdateof on date $lastupdatedte time $lastupdatedtme<i></b></td>

<td class='aetdstyle' rowspan='13'><img src='generate_graph.php?HOSTNAME=$HOSTNAME&GRAPHTYPE=nrspecs&ORDERBY=seqnr&ORDERTYPE=desc&MAX=25&GRAPHSIZE=300&GRAPHHIGHT=300&PLOTTYPE=impuls&GRAPHCOLOR=$GRAPHCOLOR&GRAPHTEXTCOLOR=$GRAPHTEXTCOLOR' align='middle' alt='Andutteye software graph' width=`300`></td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('Here you can load prior versions of the specification')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Load other version</td>

<form method='GET' action='show_specification.php'>

<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
<td class='aetdstyle'><select class='selectboxstyle' name='LOADOLDVERSION' style='WIDTH: 180'>";


while ($line = $DBFETCHARRAY($result2, $DBASSOC )) {
                $aeversion = $line["aeversion"];
                echo "<option value='$aeversion'> $aeversion.0";
}
echo "
</select> 
<input class='buttonstyle' type='reset' value='Reset'><input class='buttonstyle' type='submit' value='Load'>
</form>";

if($LOADOLDVERSION != "") {
	echo "<b><i>Version $LOADOLDVERSION.0 loaded</i></b>";
}
echo "</td>
</tr>
";


echo "
<form method='GET' action='change_specification.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'></td>
<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>
<input type='hidden' name='packages' value='$packages'></td>
<input type='hidden' name='bundles' value='$bundles'></td>

<td class='aetdstyle'><a href='#'onclick=\"alert('Here you can see which distribution this system is based on. Changing this to something else will afFect the package and software appearence of the host.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Distribution</td>
<td class='aetdstyle'><select class='selectboxstyle' name='distribution' style='WIDTH: 180'>
<option value='$distribution'> $distribution
";

while ($line = $DBFETCHARRAY($result4, $DBASSOC )) {
                $distribution = $line["distribution"];
                echo "<option value='$distribution'> $distribution";
}
echo "
</select> 
</td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('Here you can see which distribution this system is based on. Changing this to something else will afFect the package and software appearence of the host.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Patchlevel</td>
<td class='aetdstyle'><select class='selectboxstyle' name='patchlevel' style='WIDTH: 180'>

<option value='$patchlevel'> $patchlevel
";

while ($line = $DBFETCHARRAY($result3, $DBASSOC )) {
                $patchlevel = $line["patchlevel"];
                echo "<option value='$patchlevel'> $patchlevel";
}
echo "
</select> 
</td>
</tr>
<td class='aetdstyle'><a href='#'onclick=\"alert('The status is validated of the andutteye management agent. If set to disabled the agent will not perform controls on the host.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Status</td>
<td class='aetdstyle'><select class='selectboxstyle' name='status' style='WIDTH: 180'>
<option value='$status'> $status
<option value='active'> active
<option value='disabled'> disabled
</select>
</td>
</tr>


<td class='aetdstyle'><a href='#'onclick=\"alert('Group will be used when grouping and matching of configuration files in the file repository.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Group</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='aegroup' value='$aegroup'></td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('Location will be used when grouping and matching of configuration files in the file repository.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Location</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='location' value='$location'></td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('Arhitechture type will be used when grouping and matching of configuration files in the file repository.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Arhitechture type</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='archtype' value='$archtype'></td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('Description is a short information of the host and what it does.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Description</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='description' value='$description'></td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('Specify email reciptients here that shall recive notifications when something is differing or are corrected on the host by the agent.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Email reciptients</td>
<td class='aetdstyle'><input class='textboxstyle' type='text' size='50%' name='email' value='$email'></td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('If set to yes the management agent will correct the software status to be exact as it is configured on central level. If set to no only notifications will be triggered.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Allow rpmupdate</td>
<td class='aetdstyle'>";

if($allowrpmupdate == "yes" ) {
	echo "Yes<input type='radio' name='allowrpmupdate' value='yes' CHECKED>";
	echo "No<input type='radio' name='allowrpmupdate' value='no'>";
} else {
	echo "Yes<input type='radio' name='allowrpmupdate' value='yes'>";
	echo "No<input type='radio' name='allowrpmupdate' value='no' CHECKED>";
}
echo "</td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('If set to yes the management agent will correct the files to be exact as it is configured on central level. If set to no only notifications will be triggered.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Allow configupdate</td>
<td class='aetdstyle'>";

if($allowconfigupdate == "yes" ) {
	echo "Yes<input type='radio' name='allowconfigupdate' value='yes' CHECKED>";
	echo "No<input type='radio' name='allowconfigupdate' value='no'>";
} else {
	echo "Yes<input type='radio' name='allowconfigupdate' value='yes'>";
	echo "No<input type='radio' name='allowconfigupdate' value='no' CHECKED>";
}

echo "
</td>
</tr>

<td class='aetdstyle'><a href='#'onclick=\"alert('If set to yes the management agent will report all activities to the systems syslog.')\"><img src='../themes/$USERTHEME/icons/question.png' border='0'></a></td>
<td class='aetdstyle'>Allow syslog reporting</td>
<td class='aetdstyle'>";

if($allowsyslog == "yes" ) {
	echo "Yes<input type='radio' name='allowsyslog' value='yes' CHECKED>";
	echo "No<input type='radio' name='allowsyslog' value='no'>";
} else {
	echo "Yes<input type='radio' name='allowsyslog' value='yes'>";
	echo "No<input type='radio' name='allowsyslog' value='no' CHECKED>";
}
echo "
</td>
</tr>
<td class='aetdstyle'></td>
<td class='aetdstyle'>Change configuration</td><td class='aetdstyle'><input class='buttonstyle' type='reset' value='Reset'><input class='buttonstyle' type='submit' value='Submit'></td>
</form>
</tr>";

if($managementperm == "3" || $USERADMIN == "YES") {
echo "<form method='GET' action='show_specification.php'>
<input type='hidden' name='USERNAME' value='$USERNAME'></td>
<input type='hidden' name='PASSWORD' value='$PASSWORD'></td>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'></td>
<input type='hidden' name='DEL' value='$HOSTNAME'></td>";
echo "<td class='aetdstyle'></td>
<td class='aetdstyle'>Delete configuration</td><td class='aetdstyle'><input class='buttonstyle' type='submit' value='Delete' onclick=\"return confirm('Do you really want do delete all versions of specifications for $HOSTNAME. All package selections and bundle selections will also be deleted.')\"></td></tr>";
echo "</form>";
}

echo "
</td>
</tr>
 </table>";


echo "
</td>
<td class='right'></td>
 </tr>
   <tr>
    <td class='bottomleft'></td>
<td class='bottom'></td>
 <td class='bottomright'>
   <div class='armature2'></div>

</td>
</tr>
 </table>";


//
// Second table
//
echo "<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>

 <td class='topleft'>
    <div class='armature1'></div>
    </td>
 <td class='top'></td>
  <td class='topright'></td>
  </tr>
  <tr>
    <td class='left'></td>
<td class='fill'>";

$query7    = "select distinct aeversion from andutteye_man_specification where hostname = '$HOSTNAME' order by seqnr desc";
$result7   = $DBQUERY($query7) or die ("\nFailed to execute SQl-query to get distinct version data for host $HOSTNAME\n");
$aeversion = $DBFETCHARRAY($result7);  

echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>

<th class='aetableheadstyle' colspan='6'>Specified package selection</th></tr>
<form method='GET' action='prepare_packageselection.php'>

<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
<input type='hidden' name='SPECVERSION' value='$aeversion[0]'>
<input type='hidden' name='DISTRIBUTION' value='$dist'>";


echo "
<td class='aetdstyle'><b>Andutteye action</b></td>
<td class='aetdstyle'><b>Package</b></td>
<td class='aetdstyle'><b>Version</b></td>
<td class='aetdstyle'><b>Release</b></td>
<td class='aetdstyle'><b>Change selection</b></td>
</tr>";

$nr=0;
foreach ($splittedpackages as $i) {
	if($i == "") {
		break;
	}
	if (preg_match ("/^\+/", "$i")) {
                        $show="<img src='../themes/$USERTHEME/icons/bigplus.png'>";
			$style="aetdstyle";
			$tmp=split("\+", $i);
			$pkg=split("--",$tmp[1]);
			$package="$pkg[0]";
			$version="$pkg[1]";
			$release="$pkg[2]";
        }
        elseif(preg_match ("/^\-/", "$i")) {
                        $show="<img src='../themes/$USERTHEME/icons/bigminus.png'>";
		        $style="aetdstyle";
			$i = substr("$i", 1);
		        $pkg=split("--",$i);
			$package="$pkg[0]";
			$version="$pkg[1]";
			$release="$pkg[2]";
        } else {
                       $show="Undefined";
		       $style="aetdstyle";
        }
        if($version == "0") {
                       $version="Best version for defined patchlevel";
        }
        if($release == "0") {
                       $release="Best release for defined patchlevel";
        }
		      echo "<td class='$style'>$show</td>
		      <td class='$style'><b>$package</b></td>
		      <td class='$style'>$version</td>
		      <td class='$style'>$release</td>
		      <td class='aetdstyle'><input class='buttonstyle' type='submit' value='Change'></td>
		      </tr>";
$nr++;
}
if($nr == 0) {
      echo "<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Add packages'></td></tr>";
}

echo "
</form>
 </table>

</td>
<td class='right'></td>
 </tr>
   <tr>
    <td class='bottomleft'></td>
<td class='bottom'></td>
 <td class='bottomright'>
   <div class='armature2'></div>

</td>
</tr>
 </table>";

//
// Third table
//
echo "<table width='100%' heigth='100%' class='aebacktablestyle' cellspacing='0' cellpadding='0'>

 <td class='topleft'>
    <div class='armature1'></div>
    </td>
 <td class='top'></td>
  <td class='topright'></td>
  </tr>
  <tr>
    <td class='left'></td>
<td class='fill'>";


echo "
<table class='aetablestyle' border='0' cellpadding='3' cellspacing='3' width='100%' height='32'>

<th class='aetableheadstyle' colspan='6'>Specified bundle selection</th></tr>
<form method='GET' action='prepare_bundleselection.php'>";

echo "
<input type='hidden' name='USERNAME' value='$USERNAME'>
<input type='hidden' name='PASSWORD' value='$PASSWORD'>
<input type='hidden' name='HOSTNAME' value='$HOSTNAME'>
<td class='aetdstyle'><b>Andutteye action</b></td>
<td class='aetdstyle'><b>Bundles</b></td>
<td class='aetdstyle'><b>Number of packages</b></td>
<td class='aetdstyle'><b>Change selection</b></td>
</tr>";

$nr=0;
foreach ($splittedbundles as $i) {
	if($i == "") {
		break;
	}
	$query7    = "select count(*) from andutteye_man_bundles where bundle = '$i'";
	$result7   = $DBQUERY($query7) or die ("\nFailed to execute SQl-query to number of bundle packages count\n");
	$output7   = $DBFETCHARRAY($result7);


	echo "<td class='aetdstyle'><img src='../themes/$USERTHEME/icons/bigplus.png'></td>
   	      <td class='aetdstyle'><b>$i</b></td>
	      <td class='aetdstyle'><b>$output7[0] st</b></td>
	      <td class='aetdstyle'><input class='buttonstyle' type='submit' value='Change'></td>
	     </tr>";
$nr++;
}
if ($nr == 0) {
      echo "<td class='aetdstyle'><input class='buttonstyle' type='submit' value='Add bundles'></td></tr>";
}
echo "
</form>
 </table>

</td>
<td class='right'></td>
 </tr>
   <tr>
    <td class='bottomleft'></td>
<td class='bottom'></td>
 <td class='bottomright'>
   <div class='armature2'></div>

</td>
</tr>
 </table>";
?>
