<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: wap.php,v 1.21 2006/10/16 15:21:48 andutt Exp $
//
session_start();
$ContentType="text/vnd.wap.wml";
header ("Content-Type: $ContentType");

echo '
<?xml version="1.0"?>
<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.1//EN"
"http://www.wapforum.org/DTD/wml_1.1.xml">';

$ACTION = $_GET['ACTION'];

include("../config/config.php");
include("../config/dbhandler.php");

$query    = "select count(*) from andutteye_heartbeat order by seqnr desc";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show heartbeat information\n"); 
$output   = $DBFETCHARRAY($result);
$nrservers=$output[0];

$query    = "select count(*) from andutteye_alarm where status = 'OPEN' order by seqnr desc";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show active alarms\n"); 
$output   = $DBFETCHARRAY($result);
$nralarms=$output[0];

if($ACTION == "SERVER"){
$query    = "select getdate,gettime,hostname from andutteye_heartbeat order by seqnr desc";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show heartbeat information\n"); 

// Getting current date
$DATE = date("20ymd");

echo "
<wml>
<card title='Serverheartbeat'><p>
<table columns='1'>
<tr>";

while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
	       $SEQN_VALUE = $line["seqnr"];
	       $HOST_VALUE = $line["hostname"];
	       $DATE_VALUE = $line["getdate"];
	       $TIME_VALUE = $line["gettime"];

	       echo "<td>$HOST_VALUE</td>";

	       if($DATE == $DATE_VALUE) {
		       $STATUS="CHECKEDIN";
	       } else {
		       $STATUS="NOTCHECKEDIN";
	       }
	       echo "<td><i>$STATUS</i></td>";
}
echo "</tr>
</table>
</p></card>
</wml>";
}
elseif($ACTION == "ALARMS"){
$query    = "select getdate,gettime,hostname,severity,shortinformation from andutteye_alarm where status = 'OPEN' order by seqnr desc";
$result   = $DBQUERY($query) or die ("\nFailed to execute SQl-query to show alarm information\n"); 

echo "
<wml>
<card title='Activealarms'><p>
<table columns='1'>
<tr>";

while ($line = $DBFETCHARRAY($result, $DBASSOC )) {
	       $SEQN_VALUE = $line["seqnr"];
	       $HOST_VALUE = $line["hostname"];
	       $DATE_VALUE = $line["getdate"];
	       $TIME_VALUE = $line["gettime"];
	       $SEV_VALUE  = $line["severity"];
	       $SHORTINF   = $line["shortinformation"];

	       echo "<td>$HOST_VALUE $SEV_VALUE $SHORTINF</td>";
}
echo "</tr>
</table>
</p></card>
</wml>";
} else {
echo "
<wml>
<card title='Andutteye Software Suite'><p>
<table columns='1'>
<tr>
<td><anchor>Heartbeat($nrservers)<go href='wap.php?ACTION=SERVER'/></anchor></td>
<td><anchor>Activealarms($nralarms)<go href='wap.php?ACTION=ALARMS'/></anchor></td>
</tr>
</table>
</p></card>
</wml>";
}
