<?php
// 
// Copyright (C) 2004-2010 Andreas Utterberg Thundera AB.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// For the complete GPL v2 license, visit http://www.fsf.org/licenses
//
// $Id: theme.php,v 1.20 2006/10/15 16:59:27 andutt Exp $
//
/* 
Shall we use images or not, if set to NO the menubar will use text instead of images. If set to YES folowing files are 
needed in the theme directory.

activealarms.png
alarms.png
alarmstats.png
bestuptime.png
block.png
closedalarms.png
config.png
freezedalarms.png
graphtrends.png
head1.png
head2.png
heartbeat.png
home.png
information.png
last.png*
logout.png
minus.png*
monitorview.png
nodestats.png
overview.png
plus.png*
reports.png
serverlog.png
snapshots.png
softwares.png
syslog.png

Following pictures are needed and are used if you are trying to create round tables.

block.png
fill.png
xblock.png
yblock.png
*/
// Valid string value is YES or NO.
$USEIMAGES="YES";
$GRAPHCOLOR="FAFAFA";
$GRAPHTEXTCOLOR="000";

// Css stylesheat configuration is below.
echo "
<style>
body {
     color: #000000;
     font-family: Verdana, Helvetica, sans-serif;
     font-size : 10px;
     background-color: transparent;
}
a:link       {
        color: #6d6ac2;
        text-align : center;
}
a:hover      {
        color: red;
        text-align : center;
}
a:visited      {
        color: #6d6ac2;
        text-align : center;
}
.blink      {
        font-size : 12px;
        text-decoration: blink;
        color: red;
        text-align : left; bold;
}
.topleft	{
	display: block;
	height: 20;
	width: 14px;
	background: transparent url(../themes/andutteye-default/block.png) top left no-repeat;
}
.topright	{
	display: block;
	height: 20px;
	width: 14px;
	background: transparent url(../themes/andutteye-default/block.png) top right no-repeat;
}
.bottomleft	{
	display: block;
	height: 20px;
	width: 14px;
	background: transparent url(../themes/andutteye-default/block.png) bottom left no-repeat;
}
.bottomright	{
	display: block;
	height: 20px;
	width: 14px;
	background: transparent url(../themes/andutteye-default/block.png) bottom right no-repeat;
}
.top	{
	height: 20px;
	background: transparent url(../themes/andutteye-default/xblock.png) top repeat-x;
}
.bottom		{
	height: 20px;
	background: transparent url(../themes/andutteye-default/xblock.png) bottom repeat-x;
}
.left		{
	width: 14px;
	background: transparent url(../themes/andutteye-default/yblock.png) left repeat-y;
}
.right		{
	width: 14px;
	background: transparent url(../themes/andutteye-default/yblock.png) right repeat-y;
}
.fill	{
	background: transparent url(../themes/andutteye-default/fill.png) repeat;
	text-align:left;
	padding-top: 5px;
}
.armature1	{
	display: block;
	height: 30px;
	width: 14px;
}
.armature2	{
	display: block;
	height: 30px;
	width: 14px;
}
.buttonstyle{
	background: transparent url(../themes/andutteye-default/button.png);
        border: #000 1px solid;
        color: #000;
	font-family: Trebuchet, Georgia, Verdana, Arial, Helvetica, sans-serif;
        font-size : 10px;
        text-align:center;
}
.selectboxstyle{
        background-color: #EFEFEF;
        border: #000 1px solid;
	font-family: Trebuchet, Georgia, Verdana, Arial, Helvetica, sans-serif;
        font-size : 10px;
        font-color: #6d6ac2;
        text-align:left;
}
.textboxstyle{
        background-color: #EFEFEF;
        border: #000 1px solid;
	font-family: Trebuchet, Georgia, Verdana, Arial, Helvetica, sans-serif;
        font-size : 10px;
        font-color: #6d6ac2;
        text-align:left;
}
.aebacktablestyle {
	background: transparent; 
        border-top: #FFFFFF 1px solid;
        border-bottom: #FFFFFF 1px solid;
        border-left: #FFFFFF 1px solid;
        border-right: #FFFFFF 1px solid;
        border:  #FFFFFF 1px lined;
        margin: 2px;
        padding: 2px;
}
.aetablestyle {
        color: #564D79;
	background: transparent; 
        margin: 2px;
        padding: 2px;
}
.aetableheadstyle {
         background: transparent;
         color: #4C4E54;
         font-family: Verdana, Arial, Helvetica, sans-serif;
         font-size : 12px;
         margin-left   : 1px;
         margin-right  : 1px;
         text-align : left;

}
.aetdinfo {
	background: transparent url(../themes/andutteye-default/icons/question.png);
}
.aetdstyle {
         background-color: transparent;
         color: #000000;
	 font-family: Trebuchet, Georgia, Verdana, Arial, Helvetica, sans-serif;
         font-size : 11px;
         font-color: #6d6ac2;
}
.aetdmenustyle {
         background-color: transparent;
         color: #000000;
         font-family: Verdana, Arial, Helvetica, sans-serif;
         font-size : 11px;
         font-color: #6d6ac2;
	 width: 20px;
         text-align : center;
}
a.aetdmenustyle:hover { 
	color: #FAFAFA;
}
a.aetdmenustyle:link { 
	color: #FAFAFA;
}
a.aetdmenustyle:visited { 
	color: #FAFAFA;
}
.aealarmtd {
         background-color: #FFFFFF;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-bottom: #6d6ac2 1px solid;
}
.aetdharmless {
         background-color: #E1FDE1;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-top: #5C6064 1px solid;
         border-bottom: #5C6064 1px solid;
         border-left: #5C6064 1px solid;
         border-right: #5C6064 1px solid;
         border:  #5C6064 1px lined;
}
.aetdwarning {
         background-color: #FFCC66;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-top: #5C6064 1px solid;
         border-bottom: #5C6064 1px solid;
         border-left: #5C6064 1px solid;
         border-right: #5C6064 1px solid;
         border:  #5C6064 1px lined;

}
.aetdcritical {
         background-color: #F9CECF;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-top: #5C6064 1px solid;
         border-bottom: #5C6064 1px solid;
         border-left: #5C6064 1px solid;
         border-right: #5C6064 1px solid;
         border:  #5C6064 1px lined;
}
.aetdfatal {
         background-color: #C3C5B7;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-top: #5C6064 1px solid;
         border-bottom: #5C6064 1px solid;
         border-left: #5C6064 1px solid;
         border-right: #5C6064 1px solid;
         border:  #5C6064 1px lined;
}
.aetdacknowledge {
         background-color: #B0C4DE;
         color: #000000;
         font-family: Verdana, Helvetica, sans-serif;
         font-size : 11px;
         color: #000000;
         font-color: #6d6ac2;
         text-align : center;
         border-bottom: #6d6ac2 1px solid;
         border-top: #5C6064 1px solid;
         border-bottom: #5C6064 1px solid;
         border-left: #5C6064 1px solid;
         border-right: #5C6064 1px solid;
         border:  #5C6064 1px lined;
}
h3 {
        color: #A5AECA;
        font-family: Verdana, Helvetica, sans-serif;
        font-size : 11px;

}
</style>";
?>
